# Changelog

## 1.1.9.5 - 20161223

- [edit this] and this, adding new entries as needed (version nr etc is prefixed when using version bumping Makefile targets)

## 1.1.9.4 - 20160521

- [compatibility] with ghc 8.0.1
- [type system] Ongoing work for CHR based type system
- [uhc-util] Ongoing sync with uhc-util
- [compiler driver] check for writeability of directory is now on dest dir, not src dir
- [pragmas] bangpatterns pragma turned off by default
- [pragmas] bangpatterns pragma propagation to parser fixed
- [options] fixed -O0 option

## 1.1.9.3 - 20160219

- [libs] Updated version lowerbound for hashable and fclabels, via uhc-util
- [chr] Prep for new CHR solver, via uhc-util
- [doc] Cleanup: doc moved to separate repo https://github.com/atzedijkstra/uhc-doc
- [ruler] Cleanup: ruler based impl part and examples moved to separate repo https://github.com/atzedijkstra/ruler-uhc-examples
- [experiments] Cleanup: unused/obsolete code/experiments moved to separate repo https://github.com/atzedijkstra/uhc-obsolete
- [tycore] Cleanup: TyCore stuff removed
- [impredicativity] Cleanup: variant 4_2 (impredicativity 2 pass analysis) removed
- [annotations] Cleanup: variant 7_2 (annotations, strictness) mostly removed, utilities for html pretty printing left in, bit of AST as well
- [whole prog analysis] Cleanup: removal of HPT analysis, Silly, Cil, last version still having this code tagged with 'lastversionwith-wholeproggrin'
- [core] Pretty printing/dump of Core AST (for debugging purposes), accessible via --coreopt=dump-ast
- [uhc-util] Move of LexScope encoding via RLList to separate module in uhc-util
- [corerun] Additional API calls
- [grin] No longer .grin files generated, any whole grin progr stuff disabled (to be removed)
- [serialize] Serialization instances now mostly generically defined

## 1.1.9.2 - 20151027

- [corerun] CoreRun specific options via --corerunopt=...
- [corerun] Some cleanup for use in course http://foswiki.cs.uu.nl/foswiki/Cco/WebHome
- [dependencies] Removal of dependency on Data.Data/syb
- [chr] CHR machinery moved to uhc-util
- [ast dump] Framework for debugging AST: --ehopt=dump-ast & --debug-traceon=... combi allow selectively looking into AST + info

## 1.1.9.1 - 20151013

- [guarantees] This is a pre-release as far as below extensions is concerned.
- [backend] Core/CoreRun backend now better supported (e.g. via uhcl/uhcr) to allow CoreRun modules to be run, without requiring -Operwholecore (Core whole program linking). For a "hello world" only...
- [extension] Local instances have been resurrected, paper submitted to flops2016 describes what can be done. Still bugs and design issues to be sorted out.
- [extension] Generic deriving now by default off, can be turned on via deriving Generic addition to datatype def.
- [compatibility] Compatibility with ghc <7.10 versions no longer guaranteed.
- [name analysis] Name analysis & dependency analysis more fine-grained, required by local instances.

## 1.1.9.0 - 20150430

- [compatibility] ghc 7.10 compat, name clash of 'Alt' apparently now globally visible

## 1.1.8.12 - 20150430

- [compatibility] ghc 7.10 compatibility, indirectly via uhc-util
- [build] Initial work on sandbox builds, to be enabled by --enable-sandbox flag to ./configure. Does not work yet.
- [build] Strict version equality dependency on uhc-util, uulib
- [core api] Core api no longer needs ANormal patch ([#50](https://github.com/UU-ComputerScience/uhc/pull/50)).

## 1.1.8.10 - 20150327

- [build] Internal compilerdriver refactorization and start of rewrite with new compilerdriver based on a simple incremental DSL for describing compilation.

## 1.1.8.9 - 20150301

- [build] Intro of dependency on template haskell due to start of use of a lens library (fclabels, via uhc-util)
- [git] Tagging of versions, change in changelog maintenance (is not created from edit version, prepending version nr etc)

## 1.1.8.8 - 20150301

- unused version

## 1.1.8.7 - 20150219

- [compiler driver] Refactoring: top level compiler driver functions now are typed as monad transformer, requiring adapted uhc-utils>=0.1.5.0.
- [corerun] More primitives implemented.
- [corerun] CoreRun files can be serialized, now also generated by default (enabling direct running these).

## 1.1.8.6

- [build] fix for uhc-light-1.1.8.5 package build failure.

## 1.1.8.5

- [uhcr] Can run Core directly, on the fly compilation to CoreRun.
- [corerun] Generic (un)marshalling for CoreRun FFI.
- [core, api] Export of data types, new Core AST/API to express this.
- [corerun] Better fix for CoreRun access of globals during global init.

## 1.1.8.4 - 20150120

- [corerun] Fix for module references during module setup (came up during CCO).
- [corerun] Work on FFI bindings.

## 1.1.8.3 - 20141226

- [corerun, api] Changes required for CCO.

## 1.1.8.2 - 20141219

- [build] Fixes some GHC 7.8.3 Typeable warnings
- [core, api] Removed broken default alternative from case expressions API

## 1.1.8.1 - 20141217

- [core] Core prettyprinting/parsing changed such that bindings (in a let) and alternatives (of a case) now are semicolon terminated instead of curly embraced semicolon separated; should improve readability.
- [build] Separate target in makefiles for 'ehcr', with trace option.
- [corerun, api] CoreRun API extended to be usable by CCO lab exercise.

## 1.1.8.0 - 20141212

- [corerun, api] CoreRun has its own API.
- [core, api] Interface to Core main changed in that the state parameter is already passed explicitly (not implicitly added during later compiler pipeline stages), influences the api.
- [corerun] Cleaned up CoreRun AST, spec of the operational semantics under development (separate outside src/doc tree).
- [feature] Separate executable 'uhcr' as part of uhc-light for running CoreRun file .rcr as pretty printed by dump, a temporary solution.
- [corerun] Parser for CoreRun.

## 1.1.7.4 - 20141203

- [core] Detection of yes/no ANormal form of parsed Core and corresponding no/yes transformation (not tested for cases where it matters; unknown whether this is good enough for codegen to work properly)
- [cleanup] Removal of src/ruler from source tree (has its own repo)
- [api] Added better documentation and one small example program
- [api] Fix issue #36 (wrong runtime behaviour and/or crashes)

## 1.1.7.3 - 20141127

- [core] Core running engine works (FFI stuff still to be done).
- [api] Core.API made more consistent.

## 1.1.7.2 - 20141126

- [core] Core allows exports, can mix .hs and .bcr/.tcr files (tested rudimentary only).
- [api] Core.API extended.

## 1.1.7.1 - 20141119

- [api] Initial Core.API ([#31](https://github.com/UU-ComputerScience/uhc/pull/31)).
- [feature] Start with changelog.

## 1.1.7.0 - 20141118

- [feature] Initial cabal/hackage distribution tryout.
