

-- UUAGC 0.9.52.1 (build/103/lib-ehc/UHC/Light/Compiler/Core/ExtractFF)
module UHC.Light.Compiler.Core.ExtractFFE(cmodExtractFFE
, ExtractFFE (..)) where

import qualified Data.Set as Set
import qualified Data.Map as Map
import UHC.Light.Compiler.Base.Common
import UHC.Light.Compiler.Base.HsName.Builtin
import UHC.Light.Compiler.Core
import UHC.Light.Compiler.Ty









cmodExtractFFE :: CModule -> [ExtractFFE]
cmodExtractFFE m
  = ffeBinds_Syn_CodeAGItf t
  where t = wrap_CodeAGItf (sem_CodeAGItf (CodeAGItf_AGItf m)) Inh_CodeAGItf



-- | Relevant info required outside
data ExtractFFE
  = ExtractFFE
      { effeBind		:: CBind		-- ^ the actual binding
      , effeFvS			:: FvS			-- ^ the free vars occurring in the exported expr
      }

-- CAlt --------------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fvS                  : FvS
         self                 : CAlt 
   alternatives:
      alternative Alt:
         child pat            : CPat 
         child expr           : CExpr 
         visit 0:
            local fvS         : _
            local self        : _
-}
-- cata
sem_CAlt :: CAlt ->
            T_CAlt
sem_CAlt (CAlt_Alt _pat _expr) =
    (sem_CAlt_Alt (sem_CPat _pat) (sem_CExpr _expr))
-- semantic domain
type T_CAlt = ( FvS,CAlt)
sem_CAlt_Alt :: T_CPat ->
                T_CExpr ->
                T_CAlt
sem_CAlt_Alt pat_ expr_ =
    (case (expr_) of
     { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
         (case (pat_) of
          { ( _patIfldNmL,_patIfvS,_patInmL,_patIself) ->
              (case (_exprIfvS `Set.difference` Set.fromList _patInmL) of
               { _fvS ->
               (case (_fvS) of
                { _lhsOfvS ->
                (case (CAlt_Alt _patIself _exprIself) of
                 { _self ->
                 (case (_self) of
                  { _lhsOself ->
                  ( _lhsOfvS,_lhsOself) }) }) }) }) }) })
-- CAltL -------------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fvS                  : FvS
         self                 : CAltL 
   alternatives:
      alternative Cons:
         child hd             : CAlt 
         child tl             : CAltL 
         visit 0:
            local self        : _
      alternative Nil:
         visit 0:
            local self        : _
-}
-- cata
sem_CAltL :: CAltL ->
             T_CAltL
sem_CAltL list =
    (Prelude.foldr sem_CAltL_Cons sem_CAltL_Nil (Prelude.map sem_CAlt list))
-- semantic domain
type T_CAltL = ( FvS,CAltL)
sem_CAltL_Cons :: T_CAlt ->
                  T_CAltL ->
                  T_CAltL
sem_CAltL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIfvS,_tlIself) ->
         (case (hd_) of
          { ( _hdIfvS,_hdIself) ->
              (case (_hdIfvS `Set.union` _tlIfvS) of
               { _lhsOfvS ->
               (case ((:) _hdIself _tlIself) of
                { _self ->
                (case (_self) of
                 { _lhsOself ->
                 ( _lhsOfvS,_lhsOself) }) }) }) }) })
sem_CAltL_Nil :: T_CAltL
sem_CAltL_Nil =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case ([]) of
      { _self ->
      (case (_self) of
       { _lhsOself ->
       ( _lhsOfvS,_lhsOself) }) }) })
-- CBind -------------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         ffeBinds             : [ExtractFFE]
         fvS                  : FvS
         fvSMp                : FvSMp
         nm                   : HsName
         nmL                  : [HsName]
         self                 : CBind 
   alternatives:
      alternative Bind:
         child nm             : {HsName}
         child bindAspects    : CBoundL 
         visit 0:
            local self        : _
-}
-- cata
sem_CBind :: CBind ->
             T_CBind
sem_CBind (CBind_Bind _nm _bindAspects) =
    (sem_CBind_Bind _nm (sem_CBoundL _bindAspects))
-- semantic domain
type T_CBind = ( ([ExtractFFE]),FvS,FvSMp,HsName,([HsName]),CBind)
sem_CBind_Bind :: HsName ->
                  T_CBoundL ->
                  T_CBind
sem_CBind_Bind nm_ bindAspects_ =
    (case (nm_) of
     { _bindAspectsOnm ->
     (case (bindAspects_ _bindAspectsOnm) of
      { ( _bindAspectsIffeBinds,_bindAspectsIffeBounds,_bindAspectsIfvS,_bindAspectsIfvSMp,_bindAspectsInmL,_bindAspectsIself) ->
          (case (map (\(b,fv) -> ExtractFFE (CBind_Bind nm_ [b]) fv) _bindAspectsIffeBounds) of
           { _lhsOffeBinds ->
           (case (_bindAspectsIfvS) of
            { _lhsOfvS ->
            (case (Map.singleton nm_ _bindAspectsIfvS) of
             { _lhsOfvSMp ->
             (case (nm_) of
              { _lhsOnm ->
              (case ([nm_]) of
               { _lhsOnmL ->
               (case (CBind_Bind nm_ _bindAspectsIself) of
                { _self ->
                (case (_self) of
                 { _lhsOself ->
                 ( _lhsOffeBinds,_lhsOfvS,_lhsOfvSMp,_lhsOnm,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) }) })
-- CBindAnn ----------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fvS                  : FvS
         nmL                  : [HsName]
         self                 : CBindAnn 
   alternatives:
      alternative Coe:
         child coe            : {()}
         visit 0:
            local self        : _
-}
-- cata
sem_CBindAnn :: CBindAnn ->
                T_CBindAnn
sem_CBindAnn (CBindAnn_Coe _coe) =
    (sem_CBindAnn_Coe _coe)
-- semantic domain
type T_CBindAnn = ( FvS,([HsName]),CBindAnn)
sem_CBindAnn_Coe :: (()) ->
                    T_CBindAnn
sem_CBindAnn_Coe coe_ =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case ([]) of
      { _lhsOnmL ->
      (case (CBindAnn_Coe coe_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) })
-- CBindAnnL ---------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fvS                  : FvS
         nmL                  : [HsName]
         self                 : CBindAnnL 
   alternatives:
      alternative Cons:
         child hd             : CBindAnn 
         child tl             : CBindAnnL 
         visit 0:
            local self        : _
      alternative Nil:
         visit 0:
            local self        : _
-}
-- cata
sem_CBindAnnL :: CBindAnnL ->
                 T_CBindAnnL
sem_CBindAnnL list =
    (Prelude.foldr sem_CBindAnnL_Cons sem_CBindAnnL_Nil (Prelude.map sem_CBindAnn list))
-- semantic domain
type T_CBindAnnL = ( FvS,([HsName]),CBindAnnL)
sem_CBindAnnL_Cons :: T_CBindAnn ->
                      T_CBindAnnL ->
                      T_CBindAnnL
sem_CBindAnnL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIfvS,_tlInmL,_tlIself) ->
         (case (hd_) of
          { ( _hdIfvS,_hdInmL,_hdIself) ->
              (case (_hdIfvS `Set.union` _tlIfvS) of
               { _lhsOfvS ->
               (case (_hdInmL ++ _tlInmL) of
                { _lhsOnmL ->
                (case ((:) _hdIself _tlIself) of
                 { _self ->
                 (case (_self) of
                  { _lhsOself ->
                  ( _lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) }) })
sem_CBindAnnL_Nil :: T_CBindAnnL
sem_CBindAnnL_Nil =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case ([]) of
      { _lhsOnmL ->
      (case ([]) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) })
-- CBindL ------------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         ffeBinds             : [ExtractFFE]
         fvS                  : FvS
         fvSMp                : FvSMp
         nmL                  : [HsName]
         self                 : CBindL 
   alternatives:
      alternative Cons:
         child hd             : CBind 
         child tl             : CBindL 
         visit 0:
            local self        : _
      alternative Nil:
         visit 0:
            local self        : _
-}
-- cata
sem_CBindL :: CBindL ->
              T_CBindL
sem_CBindL list =
    (Prelude.foldr sem_CBindL_Cons sem_CBindL_Nil (Prelude.map sem_CBind list))
-- semantic domain
type T_CBindL = ( ([ExtractFFE]),FvS,FvSMp,([HsName]),CBindL)
sem_CBindL_Cons :: T_CBind ->
                   T_CBindL ->
                   T_CBindL
sem_CBindL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIffeBinds,_tlIfvS,_tlIfvSMp,_tlInmL,_tlIself) ->
         (case (hd_) of
          { ( _hdIffeBinds,_hdIfvS,_hdIfvSMp,_hdInm,_hdInmL,_hdIself) ->
              (case (_hdIffeBinds ++ _tlIffeBinds) of
               { _lhsOffeBinds ->
               (case (_hdIfvS `Set.union` _tlIfvS) of
                { _lhsOfvS ->
                (case (_hdIfvSMp `Map.union` _tlIfvSMp) of
                 { _lhsOfvSMp ->
                 (case (_hdInmL ++ _tlInmL) of
                  { _lhsOnmL ->
                  (case ((:) _hdIself _tlIself) of
                   { _self ->
                   (case (_self) of
                    { _lhsOself ->
                    ( _lhsOffeBinds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) })
sem_CBindL_Nil :: T_CBindL
sem_CBindL_Nil =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (Map.empty) of
       { _lhsOfvSMp ->
       (case ([]) of
        { _lhsOnmL ->
        (case ([]) of
         { _self ->
         (case (_self) of
          { _lhsOself ->
          ( _lhsOffeBinds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) })
-- CBound ------------------------------------------------------
{-
   visit 0:
      inherited attribute:
         nm                   : HsName
      synthesized attributes:
         ffeBinds             : [ExtractFFE]
         ffeBounds            : [(CBound,FvS)]
         fvS                  : FvS
         fvSMp                : FvSMp
         nmL                  : [HsName]
         self                 : CBound 
   alternatives:
      alternative Bind:
         child expr           : CExpr 
         visit 0:
            local self        : _
      alternative Val:
         child aspectKeyS     : {ACoreBindAspectKeyS}
         child mlev           : {MetaLev}
         child lbl            : {CLbl}
         child expr           : CExpr 
         visit 0:
            local self        : _
      alternative Ty:
         child aspectKeyS     : {ACoreBindAspectKeyS}
         child ty             : {Ty}
         visit 0:
            local self        : _
      alternative FFE:
         child callconv       : {FFIWay}
         child expEnt         : {ForeignEnt}
         child expr           : CExpr 
         child ty             : {Ty}
         visit 0:
            local self        : _
-}
-- cata
sem_CBound :: CBound ->
              T_CBound
sem_CBound (CBound_Bind _expr) =
    (sem_CBound_Bind (sem_CExpr _expr))
sem_CBound (CBound_Val _aspectKeyS _mlev _lbl _expr) =
    (sem_CBound_Val _aspectKeyS _mlev _lbl (sem_CExpr _expr))
sem_CBound (CBound_Ty _aspectKeyS _ty) =
    (sem_CBound_Ty _aspectKeyS _ty)
sem_CBound (CBound_FFE _callconv _expEnt _expr _ty) =
    (sem_CBound_FFE _callconv _expEnt (sem_CExpr _expr) _ty)
-- semantic domain
type T_CBound = HsName ->
                ( ([ExtractFFE]),([(CBound,FvS)]),FvS,FvSMp,([HsName]),CBound)
sem_CBound_Bind :: T_CExpr ->
                   T_CBound
sem_CBound_Bind expr_ =
    (\ _lhsInm ->
         (case (expr_) of
          { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
              (case (_exprIffeBinds) of
               { _lhsOffeBinds ->
               (case ([]) of
                { _lhsOffeBounds ->
                (case (_exprIfvS) of
                 { _lhsOfvS ->
                 (case (Map.empty) of
                  { _lhsOfvSMp ->
                  (case ([]) of
                   { _lhsOnmL ->
                   (case (CBound_Bind _exprIself) of
                    { _self ->
                    (case (_self) of
                     { _lhsOself ->
                     ( _lhsOffeBinds,_lhsOffeBounds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) }))
sem_CBound_Val :: ACoreBindAspectKeyS ->
                  MetaLev ->
                  CLbl ->
                  T_CExpr ->
                  T_CBound
sem_CBound_Val aspectKeyS_ mlev_ lbl_ expr_ =
    (\ _lhsInm ->
         (case (expr_) of
          { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
              (case (_exprIffeBinds) of
               { _lhsOffeBinds ->
               (case ([]) of
                { _lhsOffeBounds ->
                (case (_exprIfvS) of
                 { _lhsOfvS ->
                 (case (Map.empty) of
                  { _lhsOfvSMp ->
                  (case ([]) of
                   { _lhsOnmL ->
                   (case (CBound_Val aspectKeyS_ mlev_ lbl_ _exprIself) of
                    { _self ->
                    (case (_self) of
                     { _lhsOself ->
                     ( _lhsOffeBinds,_lhsOffeBounds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) }))
sem_CBound_Ty :: ACoreBindAspectKeyS ->
                 Ty ->
                 T_CBound
sem_CBound_Ty aspectKeyS_ ty_ =
    (\ _lhsInm ->
         (case ([]) of
          { _lhsOffeBinds ->
          (case ([]) of
           { _lhsOffeBounds ->
           (case (Set.empty) of
            { _lhsOfvS ->
            (case (Map.empty) of
             { _lhsOfvSMp ->
             (case ([]) of
              { _lhsOnmL ->
              (case (CBound_Ty aspectKeyS_ ty_) of
               { _self ->
               (case (_self) of
                { _lhsOself ->
                ( _lhsOffeBinds,_lhsOffeBounds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }))
sem_CBound_FFE :: FFIWay ->
                  ForeignEnt ->
                  T_CExpr ->
                  Ty ->
                  T_CBound
sem_CBound_FFE callconv_ expEnt_ expr_ ty_ =
    (\ _lhsInm ->
         (case (expr_) of
          { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
              (case (_exprIffeBinds) of
               { _lhsOffeBinds ->
               (case (CBound_FFE callconv_ expEnt_ _exprIself ty_) of
                { _self ->
                (case ([(_self,_exprIfvS)]) of
                 { _lhsOffeBounds ->
                 (case (_exprIfvS) of
                  { _lhsOfvS ->
                  (case (Map.empty) of
                   { _lhsOfvSMp ->
                   (case ([]) of
                    { _lhsOnmL ->
                    (case (_self) of
                     { _lhsOself ->
                     ( _lhsOffeBinds,_lhsOffeBounds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) }))
-- CBoundL -----------------------------------------------------
{-
   visit 0:
      inherited attribute:
         nm                   : HsName
      synthesized attributes:
         ffeBinds             : [ExtractFFE]
         ffeBounds            : [(CBound,FvS)]
         fvS                  : FvS
         fvSMp                : FvSMp
         nmL                  : [HsName]
         self                 : CBoundL 
   alternatives:
      alternative Cons:
         child hd             : CBound 
         child tl             : CBoundL 
         visit 0:
            local self        : _
      alternative Nil:
         visit 0:
            local self        : _
-}
-- cata
sem_CBoundL :: CBoundL ->
               T_CBoundL
sem_CBoundL list =
    (Prelude.foldr sem_CBoundL_Cons sem_CBoundL_Nil (Prelude.map sem_CBound list))
-- semantic domain
type T_CBoundL = HsName ->
                 ( ([ExtractFFE]),([(CBound,FvS)]),FvS,FvSMp,([HsName]),CBoundL)
sem_CBoundL_Cons :: T_CBound ->
                    T_CBoundL ->
                    T_CBoundL
sem_CBoundL_Cons hd_ tl_ =
    (\ _lhsInm ->
         (case (_lhsInm) of
          { _tlOnm ->
          (case (tl_ _tlOnm) of
           { ( _tlIffeBinds,_tlIffeBounds,_tlIfvS,_tlIfvSMp,_tlInmL,_tlIself) ->
               (case (_lhsInm) of
                { _hdOnm ->
                (case (hd_ _hdOnm) of
                 { ( _hdIffeBinds,_hdIffeBounds,_hdIfvS,_hdIfvSMp,_hdInmL,_hdIself) ->
                     (case (_hdIffeBinds ++ _tlIffeBinds) of
                      { _lhsOffeBinds ->
                      (case (_hdIffeBounds ++ _tlIffeBounds) of
                       { _lhsOffeBounds ->
                       (case (_hdIfvS `Set.union` _tlIfvS) of
                        { _lhsOfvS ->
                        (case (_hdIfvSMp `Map.union` _tlIfvSMp) of
                         { _lhsOfvSMp ->
                         (case (_hdInmL ++ _tlInmL) of
                          { _lhsOnmL ->
                          (case ((:) _hdIself _tlIself) of
                           { _self ->
                           (case (_self) of
                            { _lhsOself ->
                            ( _lhsOffeBinds,_lhsOffeBounds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) }) }) }) }))
sem_CBoundL_Nil :: T_CBoundL
sem_CBoundL_Nil =
    (\ _lhsInm ->
         (case ([]) of
          { _lhsOffeBinds ->
          (case ([]) of
           { _lhsOffeBounds ->
           (case (Set.empty) of
            { _lhsOfvS ->
            (case (Map.empty) of
             { _lhsOfvSMp ->
             (case ([]) of
              { _lhsOnmL ->
              (case ([]) of
               { _self ->
               (case (_self) of
                { _lhsOself ->
                ( _lhsOffeBinds,_lhsOffeBounds,_lhsOfvS,_lhsOfvSMp,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }))
-- CDataCon ----------------------------------------------------
{-
   alternatives:
      alternative Con:
         child conNm          : {HsName}
         child tagNr          : {Int}
         child arity          : {Int}
-}
-- cata
sem_CDataCon :: CDataCon ->
                T_CDataCon
sem_CDataCon (CDataCon_Con _conNm _tagNr _arity) =
    (sem_CDataCon_Con _conNm _tagNr _arity)
-- semantic domain
type T_CDataCon = ( )
sem_CDataCon_Con :: HsName ->
                    Int ->
                    Int ->
                    T_CDataCon
sem_CDataCon_Con conNm_ tagNr_ arity_ =
    ( )
-- CDataConL ---------------------------------------------------
{-
   alternatives:
      alternative Cons:
         child hd             : CDataCon 
         child tl             : CDataConL 
      alternative Nil:
-}
-- cata
sem_CDataConL :: CDataConL ->
                 T_CDataConL
sem_CDataConL list =
    (Prelude.foldr sem_CDataConL_Cons sem_CDataConL_Nil (Prelude.map sem_CDataCon list))
-- semantic domain
type T_CDataConL = ( )
sem_CDataConL_Cons :: T_CDataCon ->
                      T_CDataConL ->
                      T_CDataConL
sem_CDataConL_Cons hd_ tl_ =
    ( )
sem_CDataConL_Nil :: T_CDataConL
sem_CDataConL_Nil =
    ( )
-- CDeclMeta ---------------------------------------------------
{-
   alternatives:
      alternative Data:
         child tyNm           : {HsName}
         child dataCons       : CDataConL 
-}
-- cata
sem_CDeclMeta :: CDeclMeta ->
                 T_CDeclMeta
sem_CDeclMeta (CDeclMeta_Data _tyNm _dataCons) =
    (sem_CDeclMeta_Data _tyNm (sem_CDataConL _dataCons))
-- semantic domain
type T_CDeclMeta = ( )
sem_CDeclMeta_Data :: HsName ->
                      T_CDataConL ->
                      T_CDeclMeta
sem_CDeclMeta_Data tyNm_ dataCons_ =
    ( )
-- CDeclMetaL --------------------------------------------------
{-
   alternatives:
      alternative Cons:
         child hd             : CDeclMeta 
         child tl             : CDeclMetaL 
      alternative Nil:
-}
-- cata
sem_CDeclMetaL :: CDeclMetaL ->
                  T_CDeclMetaL
sem_CDeclMetaL list =
    (Prelude.foldr sem_CDeclMetaL_Cons sem_CDeclMetaL_Nil (Prelude.map sem_CDeclMeta list))
-- semantic domain
type T_CDeclMetaL = ( )
sem_CDeclMetaL_Cons :: T_CDeclMeta ->
                       T_CDeclMetaL ->
                       T_CDeclMetaL
sem_CDeclMetaL_Cons hd_ tl_ =
    ( )
sem_CDeclMetaL_Nil :: T_CDeclMetaL
sem_CDeclMetaL_Nil =
    ( )
-- CExport -----------------------------------------------------
{-
   alternatives:
      alternative Export:
         child nm             : {HsName}
      alternative ExportData:
         child nm             : {HsName}
         child mbConNmL       : {Maybe [HsName]}
-}
-- cata
sem_CExport :: CExport ->
               T_CExport
sem_CExport (CExport_Export _nm) =
    (sem_CExport_Export _nm)
sem_CExport (CExport_ExportData _nm _mbConNmL) =
    (sem_CExport_ExportData _nm _mbConNmL)
-- semantic domain
type T_CExport = ( )
sem_CExport_Export :: HsName ->
                      T_CExport
sem_CExport_Export nm_ =
    ( )
sem_CExport_ExportData :: HsName ->
                          (Maybe [HsName]) ->
                          T_CExport
sem_CExport_ExportData nm_ mbConNmL_ =
    ( )
-- CExportL ----------------------------------------------------
{-
   alternatives:
      alternative Cons:
         child hd             : CExport 
         child tl             : CExportL 
      alternative Nil:
-}
-- cata
sem_CExportL :: CExportL ->
                T_CExportL
sem_CExportL list =
    (Prelude.foldr sem_CExportL_Cons sem_CExportL_Nil (Prelude.map sem_CExport list))
-- semantic domain
type T_CExportL = ( )
sem_CExportL_Cons :: T_CExport ->
                     T_CExportL ->
                     T_CExportL
sem_CExportL_Cons hd_ tl_ =
    ( )
sem_CExportL_Nil :: T_CExportL
sem_CExportL_Nil =
    ( )
-- CExpr -------------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         ffeBinds             : [ExtractFFE]
         fvS                  : FvS
         self                 : CExpr 
   alternatives:
      alternative Var:
         child ref            : {ACoreBindRef}
         visit 0:
            local nm          : {HsName}
            local self        : _
      alternative Int:
         child int            : {Int}
         visit 0:
            local self        : _
      alternative Char:
         child char           : {Char}
         visit 0:
            local self        : _
      alternative String:
         child str            : {String}
         visit 0:
            local self        : _
      alternative Integer:
         child integer        : {Integer}
         visit 0:
            local self        : _
      alternative Tup:
         child tag            : {CTag}
         visit 0:
            local self        : _
      alternative Let:
         child categ          : {CBindCateg}
         child binds          : CBindL 
         child body           : CExpr 
         visit 0:
            local fvS         : _
            local self        : _
      alternative App:
         child func           : CExpr 
         child arg            : CBound 
         visit 0:
            local fvS         : _
            local self        : _
      alternative Lam:
         child bind           : CBind 
         child body           : CExpr 
         visit 0:
            local argNm       : _
            local fvS         : _
            local self        : _
      alternative Case:
         child expr           : CExpr 
         child alts           : CAltL 
         child dflt           : CExpr 
         visit 0:
            local self        : _
      alternative CaseAltFail:
         child failReason     : {CaseAltFailReason}
         child errorExpr      : CExpr 
         visit 0:
            local self        : _
      alternative TupDel:
         child expr           : CExpr 
         child tag            : {CTag}
         child nm             : {HsName}
         child offset         : CExpr 
         visit 0:
            local self        : _
      alternative TupIns:
         child expr           : CExpr 
         child tag            : {CTag}
         child nm             : {HsName}
         child offset         : CExpr 
         child fldExpr        : CExpr 
         visit 0:
            local self        : _
      alternative TupUpd:
         child expr           : CExpr 
         child tag            : {CTag}
         child nm             : {HsName}
         child offset         : CExpr 
         child fldExpr        : CExpr 
         visit 0:
            local self        : _
      alternative FFI:
         child callconv       : {FFIWay}
         child safety         : {String}
         child impEnt         : {ForeignEnt}
         child ty             : {Ty}
         visit 0:
            local self        : _
      alternative Dbg:
         child info           : {String}
         visit 0:
            local self        : _
      alternative Hole:
         child uid            : {UID}
         visit 0:
            local self        : _
      alternative HoleLet:
         child bindsUid       : {UID}
         child body           : CExpr 
         visit 0:
            local self        : _
      alternative CoeArg:
         visit 0:
            local self        : _
      alternative ImplsApp:
         child func           : CExpr 
         child uid            : {ImplsVarId}
         visit 0:
            local self        : _
      alternative ImplsLam:
         child uid            : {ImplsVarId}
         child body           : CExpr 
         visit 0:
            local self        : _
      alternative Ann:
         child ann            : CExprAnn 
         child expr           : CExpr 
         visit 0:
            local self        : _
-}
-- cata
sem_CExpr :: CExpr ->
             T_CExpr
sem_CExpr (CExpr_Var _ref) =
    (sem_CExpr_Var _ref)
sem_CExpr (CExpr_Int _int) =
    (sem_CExpr_Int _int)
sem_CExpr (CExpr_Char _char) =
    (sem_CExpr_Char _char)
sem_CExpr (CExpr_String _str) =
    (sem_CExpr_String _str)
sem_CExpr (CExpr_Integer _integer) =
    (sem_CExpr_Integer _integer)
sem_CExpr (CExpr_Tup _tag) =
    (sem_CExpr_Tup _tag)
sem_CExpr (CExpr_Let _categ _binds _body) =
    (sem_CExpr_Let _categ (sem_CBindL _binds) (sem_CExpr _body))
sem_CExpr (CExpr_App _func _arg) =
    (sem_CExpr_App (sem_CExpr _func) (sem_CBound _arg))
sem_CExpr (CExpr_Lam _bind _body) =
    (sem_CExpr_Lam (sem_CBind _bind) (sem_CExpr _body))
sem_CExpr (CExpr_Case _expr _alts _dflt) =
    (sem_CExpr_Case (sem_CExpr _expr) (sem_CAltL _alts) (sem_CExpr _dflt))
sem_CExpr (CExpr_CaseAltFail _failReason _errorExpr) =
    (sem_CExpr_CaseAltFail _failReason (sem_CExpr _errorExpr))
sem_CExpr (CExpr_TupDel _expr _tag _nm _offset) =
    (sem_CExpr_TupDel (sem_CExpr _expr) _tag _nm (sem_CExpr _offset))
sem_CExpr (CExpr_TupIns _expr _tag _nm _offset _fldExpr) =
    (sem_CExpr_TupIns (sem_CExpr _expr) _tag _nm (sem_CExpr _offset) (sem_CExpr _fldExpr))
sem_CExpr (CExpr_TupUpd _expr _tag _nm _offset _fldExpr) =
    (sem_CExpr_TupUpd (sem_CExpr _expr) _tag _nm (sem_CExpr _offset) (sem_CExpr _fldExpr))
sem_CExpr (CExpr_FFI _callconv _safety _impEnt _ty) =
    (sem_CExpr_FFI _callconv _safety _impEnt _ty)
sem_CExpr (CExpr_Dbg _info) =
    (sem_CExpr_Dbg _info)
sem_CExpr (CExpr_Hole _uid) =
    (sem_CExpr_Hole _uid)
sem_CExpr (CExpr_HoleLet _bindsUid _body) =
    (sem_CExpr_HoleLet _bindsUid (sem_CExpr _body))
sem_CExpr (CExpr_CoeArg) =
    (sem_CExpr_CoeArg)
sem_CExpr (CExpr_ImplsApp _func _uid) =
    (sem_CExpr_ImplsApp (sem_CExpr _func) _uid)
sem_CExpr (CExpr_ImplsLam _uid _body) =
    (sem_CExpr_ImplsLam _uid (sem_CExpr _body))
sem_CExpr (CExpr_Ann _ann _expr) =
    (sem_CExpr_Ann (sem_CExprAnn _ann) (sem_CExpr _expr))
-- semantic domain
type T_CExpr = ( ([ExtractFFE]),FvS,CExpr)
sem_CExpr_Var :: ACoreBindRef ->
                 T_CExpr
sem_CExpr_Var ref_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (acbrefNm ref_) of
      { _nm ->
      (case (Set.singleton _nm) of
       { _lhsOfvS ->
       (case (CExpr_Var ref_) of
        { _self ->
        (case (_self) of
         { _lhsOself ->
         ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) })
sem_CExpr_Int :: Int ->
                 T_CExpr
sem_CExpr_Int int_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_Int int_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_Char :: Char ->
                  T_CExpr
sem_CExpr_Char char_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_Char char_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_String :: String ->
                    T_CExpr
sem_CExpr_String str_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_String str_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_Integer :: Integer ->
                     T_CExpr
sem_CExpr_Integer integer_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_Integer integer_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_Tup :: CTag ->
                 T_CExpr
sem_CExpr_Tup tag_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_Tup tag_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_Let :: CBindCateg ->
                 T_CBindL ->
                 T_CExpr ->
                 T_CExpr
sem_CExpr_Let categ_ binds_ body_ =
    (case (body_) of
     { ( _bodyIffeBinds,_bodyIfvS,_bodyIself) ->
         (case (binds_) of
          { ( _bindsIffeBinds,_bindsIfvS,_bindsIfvSMp,_bindsInmL,_bindsIself) ->
              (case (_bindsIffeBinds ++ _bodyIffeBinds) of
               { _lhsOffeBinds ->
               (case ((_bodyIfvS `Set.union` _bindsIfvS) `Set.difference` Set.fromList _bindsInmL) of
                { _fvS ->
                (case (_fvS) of
                 { _lhsOfvS ->
                 (case (CExpr_Let categ_ _bindsIself _bodyIself) of
                  { _self ->
                  (case (_self) of
                   { _lhsOself ->
                   ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) }) })
sem_CExpr_App :: T_CExpr ->
                 T_CBound ->
                 T_CExpr
sem_CExpr_App func_ arg_ =
    (case (hsnUnknown) of
     { _argOnm ->
     (case (arg_ _argOnm) of
      { ( _argIffeBinds,_argIffeBounds,_argIfvS,_argIfvSMp,_argInmL,_argIself) ->
          (case (func_) of
           { ( _funcIffeBinds,_funcIfvS,_funcIself) ->
               (case (_funcIffeBinds ++ _argIffeBinds) of
                { _lhsOffeBinds ->
                (case (_funcIfvS `Set.union` _argIfvS) of
                 { _fvS ->
                 (case (_fvS) of
                  { _lhsOfvS ->
                  (case (CExpr_App _funcIself _argIself) of
                   { _self ->
                   (case (_self) of
                    { _lhsOself ->
                    ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) }) }) })
sem_CExpr_Lam :: T_CBind ->
                 T_CExpr ->
                 T_CExpr
sem_CExpr_Lam bind_ body_ =
    (case (body_) of
     { ( _bodyIffeBinds,_bodyIfvS,_bodyIself) ->
         (case (bind_) of
          { ( _bindIffeBinds,_bindIfvS,_bindIfvSMp,_bindInm,_bindInmL,_bindIself) ->
              (case (_bindIffeBinds ++ _bodyIffeBinds) of
               { _lhsOffeBinds ->
               (case (_bindInm) of
                { _argNm ->
                (case (_argNm `Set.delete` _bodyIfvS) of
                 { _fvS ->
                 (case (_fvS) of
                  { _lhsOfvS ->
                  (case (CExpr_Lam _bindIself _bodyIself) of
                   { _self ->
                   (case (_self) of
                    { _lhsOself ->
                    ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) }) }) })
sem_CExpr_Case :: T_CExpr ->
                  T_CAltL ->
                  T_CExpr ->
                  T_CExpr
sem_CExpr_Case expr_ alts_ dflt_ =
    (case (dflt_) of
     { ( _dfltIffeBinds,_dfltIfvS,_dfltIself) ->
         (case (expr_) of
          { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
              (case (_exprIffeBinds ++ _dfltIffeBinds) of
               { _lhsOffeBinds ->
               (case (alts_) of
                { ( _altsIfvS,_altsIself) ->
                    (case (_exprIfvS `Set.union` _altsIfvS `Set.union` _dfltIfvS) of
                     { _lhsOfvS ->
                     (case (CExpr_Case _exprIself _altsIself _dfltIself) of
                      { _self ->
                      (case (_self) of
                       { _lhsOself ->
                       ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) }) })
sem_CExpr_CaseAltFail :: CaseAltFailReason ->
                         T_CExpr ->
                         T_CExpr
sem_CExpr_CaseAltFail failReason_ errorExpr_ =
    (case (errorExpr_) of
     { ( _errorExprIffeBinds,_errorExprIfvS,_errorExprIself) ->
         (case (_errorExprIffeBinds) of
          { _lhsOffeBinds ->
          (case (_errorExprIfvS) of
           { _lhsOfvS ->
           (case (CExpr_CaseAltFail failReason_ _errorExprIself) of
            { _self ->
            (case (_self) of
             { _lhsOself ->
             ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) })
sem_CExpr_TupDel :: T_CExpr ->
                    CTag ->
                    HsName ->
                    T_CExpr ->
                    T_CExpr
sem_CExpr_TupDel expr_ tag_ nm_ offset_ =
    (case (offset_) of
     { ( _offsetIffeBinds,_offsetIfvS,_offsetIself) ->
         (case (expr_) of
          { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
              (case (_exprIffeBinds ++ _offsetIffeBinds) of
               { _lhsOffeBinds ->
               (case (_exprIfvS `Set.union` _offsetIfvS) of
                { _lhsOfvS ->
                (case (CExpr_TupDel _exprIself tag_ nm_ _offsetIself) of
                 { _self ->
                 (case (_self) of
                  { _lhsOself ->
                  ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) })
sem_CExpr_TupIns :: T_CExpr ->
                    CTag ->
                    HsName ->
                    T_CExpr ->
                    T_CExpr ->
                    T_CExpr
sem_CExpr_TupIns expr_ tag_ nm_ offset_ fldExpr_ =
    (case (fldExpr_) of
     { ( _fldExprIffeBinds,_fldExprIfvS,_fldExprIself) ->
         (case (offset_) of
          { ( _offsetIffeBinds,_offsetIfvS,_offsetIself) ->
              (case (expr_) of
               { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
                   (case (_exprIffeBinds ++ _offsetIffeBinds ++ _fldExprIffeBinds) of
                    { _lhsOffeBinds ->
                    (case (_exprIfvS `Set.union` _offsetIfvS `Set.union` _fldExprIfvS) of
                     { _lhsOfvS ->
                     (case (CExpr_TupIns _exprIself tag_ nm_ _offsetIself _fldExprIself) of
                      { _self ->
                      (case (_self) of
                       { _lhsOself ->
                       ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) }) })
sem_CExpr_TupUpd :: T_CExpr ->
                    CTag ->
                    HsName ->
                    T_CExpr ->
                    T_CExpr ->
                    T_CExpr
sem_CExpr_TupUpd expr_ tag_ nm_ offset_ fldExpr_ =
    (case (fldExpr_) of
     { ( _fldExprIffeBinds,_fldExprIfvS,_fldExprIself) ->
         (case (offset_) of
          { ( _offsetIffeBinds,_offsetIfvS,_offsetIself) ->
              (case (expr_) of
               { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
                   (case (_exprIffeBinds ++ _offsetIffeBinds ++ _fldExprIffeBinds) of
                    { _lhsOffeBinds ->
                    (case (_exprIfvS `Set.union` _offsetIfvS `Set.union` _fldExprIfvS) of
                     { _lhsOfvS ->
                     (case (CExpr_TupUpd _exprIself tag_ nm_ _offsetIself _fldExprIself) of
                      { _self ->
                      (case (_self) of
                       { _lhsOself ->
                       ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) }) })
sem_CExpr_FFI :: FFIWay ->
                 String ->
                 ForeignEnt ->
                 Ty ->
                 T_CExpr
sem_CExpr_FFI callconv_ safety_ impEnt_ ty_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_FFI callconv_ safety_ impEnt_ ty_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_Dbg :: String ->
                 T_CExpr
sem_CExpr_Dbg info_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_Dbg info_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_Hole :: UID ->
                  T_CExpr
sem_CExpr_Hole uid_ =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_Hole uid_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_HoleLet :: UID ->
                     T_CExpr ->
                     T_CExpr
sem_CExpr_HoleLet bindsUid_ body_ =
    (case (body_) of
     { ( _bodyIffeBinds,_bodyIfvS,_bodyIself) ->
         (case (_bodyIffeBinds) of
          { _lhsOffeBinds ->
          (case (_bodyIfvS) of
           { _lhsOfvS ->
           (case (CExpr_HoleLet bindsUid_ _bodyIself) of
            { _self ->
            (case (_self) of
             { _lhsOself ->
             ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) })
sem_CExpr_CoeArg :: T_CExpr
sem_CExpr_CoeArg =
    (case ([]) of
     { _lhsOffeBinds ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case (CExpr_CoeArg) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) })
sem_CExpr_ImplsApp :: T_CExpr ->
                      ImplsVarId ->
                      T_CExpr
sem_CExpr_ImplsApp func_ uid_ =
    (case (func_) of
     { ( _funcIffeBinds,_funcIfvS,_funcIself) ->
         (case (_funcIffeBinds) of
          { _lhsOffeBinds ->
          (case (_funcIfvS) of
           { _lhsOfvS ->
           (case (CExpr_ImplsApp _funcIself uid_) of
            { _self ->
            (case (_self) of
             { _lhsOself ->
             ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) })
sem_CExpr_ImplsLam :: ImplsVarId ->
                      T_CExpr ->
                      T_CExpr
sem_CExpr_ImplsLam uid_ body_ =
    (case (body_) of
     { ( _bodyIffeBinds,_bodyIfvS,_bodyIself) ->
         (case (_bodyIffeBinds) of
          { _lhsOffeBinds ->
          (case (_bodyIfvS) of
           { _lhsOfvS ->
           (case (CExpr_ImplsLam uid_ _bodyIself) of
            { _self ->
            (case (_self) of
             { _lhsOself ->
             ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) })
sem_CExpr_Ann :: T_CExprAnn ->
                 T_CExpr ->
                 T_CExpr
sem_CExpr_Ann ann_ expr_ =
    (case (expr_) of
     { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
         (case (_exprIffeBinds) of
          { _lhsOffeBinds ->
          (case (ann_) of
           { ( _annIfvS,_annIself) ->
               (case (_annIfvS `Set.union` _exprIfvS) of
                { _lhsOfvS ->
                (case (CExpr_Ann _annIself _exprIself) of
                 { _self ->
                 (case (_self) of
                  { _lhsOself ->
                  ( _lhsOffeBinds,_lhsOfvS,_lhsOself) }) }) }) }) }) })
-- CExprAnn ----------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fvS                  : FvS
         self                 : CExprAnn 
   alternatives:
      alternative Ty:
         child ty             : {Ty}
         visit 0:
            local self        : _
      alternative Debug:
         child info           : {String}
         visit 0:
            local self        : _
-}
-- cata
sem_CExprAnn :: CExprAnn ->
                T_CExprAnn
sem_CExprAnn (CExprAnn_Ty _ty) =
    (sem_CExprAnn_Ty _ty)
sem_CExprAnn (CExprAnn_Debug _info) =
    (sem_CExprAnn_Debug _info)
-- semantic domain
type T_CExprAnn = ( FvS,CExprAnn)
sem_CExprAnn_Ty :: Ty ->
                   T_CExprAnn
sem_CExprAnn_Ty ty_ =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case (CExprAnn_Ty ty_) of
      { _self ->
      (case (_self) of
       { _lhsOself ->
       ( _lhsOfvS,_lhsOself) }) }) })
sem_CExprAnn_Debug :: String ->
                      T_CExprAnn
sem_CExprAnn_Debug info_ =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case (CExprAnn_Debug info_) of
      { _self ->
      (case (_self) of
       { _lhsOself ->
       ( _lhsOfvS,_lhsOself) }) }) })
-- CImport -----------------------------------------------------
{-
   alternatives:
      alternative Import:
         child nm             : {HsName}
-}
-- cata
sem_CImport :: CImport ->
               T_CImport
sem_CImport (CImport_Import _nm) =
    (sem_CImport_Import _nm)
-- semantic domain
type T_CImport = ( )
sem_CImport_Import :: HsName ->
                      T_CImport
sem_CImport_Import nm_ =
    ( )
-- CImportL ----------------------------------------------------
{-
   alternatives:
      alternative Cons:
         child hd             : CImport 
         child tl             : CImportL 
      alternative Nil:
-}
-- cata
sem_CImportL :: CImportL ->
                T_CImportL
sem_CImportL list =
    (Prelude.foldr sem_CImportL_Cons sem_CImportL_Nil (Prelude.map sem_CImport list))
-- semantic domain
type T_CImportL = ( )
sem_CImportL_Cons :: T_CImport ->
                     T_CImportL ->
                     T_CImportL
sem_CImportL_Cons hd_ tl_ =
    ( )
sem_CImportL_Nil :: T_CImportL
sem_CImportL_Nil =
    ( )
-- CModule -----------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         ffeBinds             : [ExtractFFE]
         fvS                  : FvS
   alternatives:
      alternative Mod:
         child moduleNm       : {HsName}
         child exports        : CExportL 
         child imports        : CImportL 
         child declMetas      : CDeclMetaL 
         child expr           : CExpr 
-}
-- cata
sem_CModule :: CModule ->
               T_CModule
sem_CModule (CModule_Mod _moduleNm _exports _imports _declMetas _expr) =
    (sem_CModule_Mod _moduleNm (sem_CExportL _exports) (sem_CImportL _imports) (sem_CDeclMetaL _declMetas) (sem_CExpr _expr))
-- semantic domain
type T_CModule = ( ([ExtractFFE]),FvS)
sem_CModule_Mod :: HsName ->
                   T_CExportL ->
                   T_CImportL ->
                   T_CDeclMetaL ->
                   T_CExpr ->
                   T_CModule
sem_CModule_Mod moduleNm_ exports_ imports_ declMetas_ expr_ =
    (case (expr_) of
     { ( _exprIffeBinds,_exprIfvS,_exprIself) ->
         (case (_exprIffeBinds) of
          { _lhsOffeBinds ->
          (case (_exprIfvS) of
           { _lhsOfvS ->
           ( _lhsOffeBinds,_lhsOfvS) }) }) })
-- CPat --------------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fldNmL               : [HsName]
         fvS                  : FvS
         nmL                  : [HsName]
         self                 : CPat 
   alternatives:
      alternative Var:
         child pnm            : {HsName}
         visit 0:
            local self        : _
      alternative Con:
         child tag            : {CTag}
         child rest           : CPatRest 
         child binds          : CPatFldL 
         visit 0:
            local self        : _
      alternative Int:
         child int            : {Int}
         visit 0:
            local self        : _
      alternative Char:
         child char           : {Char}
         visit 0:
            local self        : _
      alternative BoolExpr:
         child cexpr          : {CExpr}
         visit 0:
            local self        : _
-}
-- cata
sem_CPat :: CPat ->
            T_CPat
sem_CPat (CPat_Var _pnm) =
    (sem_CPat_Var _pnm)
sem_CPat (CPat_Con _tag _rest _binds) =
    (sem_CPat_Con _tag (sem_CPatRest _rest) (sem_CPatFldL _binds))
sem_CPat (CPat_Int _int) =
    (sem_CPat_Int _int)
sem_CPat (CPat_Char _char) =
    (sem_CPat_Char _char)
sem_CPat (CPat_BoolExpr _cexpr) =
    (sem_CPat_BoolExpr _cexpr)
-- semantic domain
type T_CPat = ( ([HsName]),FvS,([HsName]),CPat)
sem_CPat_Var :: HsName ->
                T_CPat
sem_CPat_Var pnm_ =
    (case ([]) of
     { _lhsOfldNmL ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case ([pnm_]) of
       { _lhsOnmL ->
       (case (CPat_Var pnm_) of
        { _self ->
        (case (_self) of
         { _lhsOself ->
         ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) })
sem_CPat_Con :: CTag ->
                T_CPatRest ->
                T_CPatFldL ->
                T_CPat
sem_CPat_Con tag_ rest_ binds_ =
    (case (binds_) of
     { ( _bindsIfldNmL,_bindsIfvS,_bindsInmL,_bindsIself) ->
         (case (_bindsIfldNmL) of
          { _lhsOfldNmL ->
          (case (rest_) of
           { ( _restIfvS,_restInmL,_restIself) ->
               (case (_restIfvS `Set.union` _bindsIfvS) of
                { _lhsOfvS ->
                (case (_restInmL ++ _bindsInmL) of
                 { _lhsOnmL ->
                 (case (CPat_Con tag_ _restIself _bindsIself) of
                  { _self ->
                  (case (_self) of
                   { _lhsOself ->
                   ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) }) }) })
sem_CPat_Int :: Int ->
                T_CPat
sem_CPat_Int int_ =
    (case ([]) of
     { _lhsOfldNmL ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case ([]) of
       { _lhsOnmL ->
       (case (CPat_Int int_) of
        { _self ->
        (case (_self) of
         { _lhsOself ->
         ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) })
sem_CPat_Char :: Char ->
                 T_CPat
sem_CPat_Char char_ =
    (case ([]) of
     { _lhsOfldNmL ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case ([]) of
       { _lhsOnmL ->
       (case (CPat_Char char_) of
        { _self ->
        (case (_self) of
         { _lhsOself ->
         ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) })
sem_CPat_BoolExpr :: CExpr ->
                     T_CPat
sem_CPat_BoolExpr cexpr_ =
    (case ([]) of
     { _lhsOfldNmL ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case ([]) of
       { _lhsOnmL ->
       (case (CPat_BoolExpr cexpr_) of
        { _self ->
        (case (_self) of
         { _lhsOself ->
         ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) })
-- CPatFld -----------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fldNmL               : [HsName]
         fvS                  : FvS
         nmL                  : [HsName]
         self                 : CPatFld 
   alternatives:
      alternative Fld:
         child lbl            : {HsName}
         child offset         : CExpr 
         child bind           : CBind 
         child fldAnns        : CBindAnnL 
         visit 0:
            local fldNm       : _
            local self        : _
-}
-- cata
sem_CPatFld :: CPatFld ->
               T_CPatFld
sem_CPatFld (CPatFld_Fld _lbl _offset _bind _fldAnns) =
    (sem_CPatFld_Fld _lbl (sem_CExpr _offset) (sem_CBind _bind) (sem_CBindAnnL _fldAnns))
-- semantic domain
type T_CPatFld = ( ([HsName]),FvS,([HsName]),CPatFld)
sem_CPatFld_Fld :: HsName ->
                   T_CExpr ->
                   T_CBind ->
                   T_CBindAnnL ->
                   T_CPatFld
sem_CPatFld_Fld lbl_ offset_ bind_ fldAnns_ =
    (case (bind_) of
     { ( _bindIffeBinds,_bindIfvS,_bindIfvSMp,_bindInm,_bindInmL,_bindIself) ->
         (case (_bindInm) of
          { _fldNm ->
          (case ([_fldNm]) of
           { _lhsOfldNmL ->
           (case (fldAnns_) of
            { ( _fldAnnsIfvS,_fldAnnsInmL,_fldAnnsIself) ->
                (case (offset_) of
                 { ( _offsetIffeBinds,_offsetIfvS,_offsetIself) ->
                     (case (_offsetIfvS `Set.union` _bindIfvS `Set.union` _fldAnnsIfvS) of
                      { _lhsOfvS ->
                      (case ([_fldNm]) of
                       { _lhsOnmL ->
                       (case (CPatFld_Fld lbl_ _offsetIself _bindIself _fldAnnsIself) of
                        { _self ->
                        (case (_self) of
                         { _lhsOself ->
                         ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) }) }) }) }) })
-- CPatFldL ----------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fldNmL               : [HsName]
         fvS                  : FvS
         nmL                  : [HsName]
         self                 : CPatFldL 
   alternatives:
      alternative Cons:
         child hd             : CPatFld 
         child tl             : CPatFldL 
         visit 0:
            local self        : _
      alternative Nil:
         visit 0:
            local self        : _
-}
-- cata
sem_CPatFldL :: CPatFldL ->
                T_CPatFldL
sem_CPatFldL list =
    (Prelude.foldr sem_CPatFldL_Cons sem_CPatFldL_Nil (Prelude.map sem_CPatFld list))
-- semantic domain
type T_CPatFldL = ( ([HsName]),FvS,([HsName]),CPatFldL)
sem_CPatFldL_Cons :: T_CPatFld ->
                     T_CPatFldL ->
                     T_CPatFldL
sem_CPatFldL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIfldNmL,_tlIfvS,_tlInmL,_tlIself) ->
         (case (hd_) of
          { ( _hdIfldNmL,_hdIfvS,_hdInmL,_hdIself) ->
              (case (_hdIfldNmL ++ _tlIfldNmL) of
               { _lhsOfldNmL ->
               (case (_hdIfvS `Set.union` _tlIfvS) of
                { _lhsOfvS ->
                (case (_hdInmL ++ _tlInmL) of
                 { _lhsOnmL ->
                 (case ((:) _hdIself _tlIself) of
                  { _self ->
                  (case (_self) of
                   { _lhsOself ->
                   ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) }) }) })
sem_CPatFldL_Nil :: T_CPatFldL
sem_CPatFldL_Nil =
    (case ([]) of
     { _lhsOfldNmL ->
     (case (Set.empty) of
      { _lhsOfvS ->
      (case ([]) of
       { _lhsOnmL ->
       (case ([]) of
        { _self ->
        (case (_self) of
         { _lhsOself ->
         ( _lhsOfldNmL,_lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) }) })
-- CPatRest ----------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         fvS                  : FvS
         nmL                  : [HsName]
         self                 : CPatRest 
   alternatives:
      alternative Var:
         child nm             : {HsName}
         visit 0:
            local self        : _
      alternative Empty:
         visit 0:
            local self        : _
-}
-- cata
sem_CPatRest :: CPatRest ->
                T_CPatRest
sem_CPatRest (CPatRest_Var _nm) =
    (sem_CPatRest_Var _nm)
sem_CPatRest (CPatRest_Empty) =
    (sem_CPatRest_Empty)
-- semantic domain
type T_CPatRest = ( FvS,([HsName]),CPatRest)
sem_CPatRest_Var :: HsName ->
                    T_CPatRest
sem_CPatRest_Var nm_ =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case ([nm_]) of
      { _lhsOnmL ->
      (case (CPatRest_Var nm_) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) })
sem_CPatRest_Empty :: T_CPatRest
sem_CPatRest_Empty =
    (case (Set.empty) of
     { _lhsOfvS ->
     (case ([]) of
      { _lhsOnmL ->
      (case (CPatRest_Empty) of
       { _self ->
       (case (_self) of
        { _lhsOself ->
        ( _lhsOfvS,_lhsOnmL,_lhsOself) }) }) }) })
-- CodeAGItf ---------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         ffeBinds             : [ExtractFFE]
   alternatives:
      alternative AGItf:
         child module         : CModule 
-}
-- cata
sem_CodeAGItf :: CodeAGItf ->
                 T_CodeAGItf
sem_CodeAGItf (CodeAGItf_AGItf _module) =
    (sem_CodeAGItf_AGItf (sem_CModule _module))
-- semantic domain
type T_CodeAGItf = ( ([ExtractFFE]))
data Inh_CodeAGItf = Inh_CodeAGItf {}
data Syn_CodeAGItf = Syn_CodeAGItf {ffeBinds_Syn_CodeAGItf :: !(([ExtractFFE]))}
wrap_CodeAGItf :: T_CodeAGItf ->
                  Inh_CodeAGItf ->
                  Syn_CodeAGItf
wrap_CodeAGItf sem (Inh_CodeAGItf) =
    (let ( _lhsOffeBinds) = sem
     in  (Syn_CodeAGItf _lhsOffeBinds))
sem_CodeAGItf_AGItf :: T_CModule ->
                       T_CodeAGItf
sem_CodeAGItf_AGItf module_ =
    (case (module_) of
     { ( _moduleIffeBinds,_moduleIfvS) ->
         (case (_moduleIffeBinds) of
          { _lhsOffeBinds ->
          ( _lhsOffeBinds) }) })