

-- UUAGC 0.9.52.1 (build/103/lib-ehc/UHC/Light/Compiler/Core/Trf/LetFl)
module UHC.Light.Compiler.Core.Trf.LetFlattenStrict(cmodTrfLetFlattenStrict) where

import UHC.Light.Compiler.Base.Common
import UHC.Light.Compiler.Core
import UHC.Light.Compiler.Ty
import UHC.Light.Compiler.AbstractCore
import Data.Maybe
import qualified UHC.Util.FastSeq as Seq









cmodTrfLetFlattenStrict :: CModule -> CModule
cmodTrfLetFlattenStrict cmod
  =  let  t = wrap_CodeAGItf (sem_CodeAGItf (CodeAGItf_AGItf cmod)) Inh_CodeAGItf
     in   cTrf_Syn_CodeAGItf t



type Lift   = (Seq.Seq CBind,CExpr)
type MbLift = Maybe Lift

-- CAlt --------------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CAlt 
   alternatives:
      alternative Alt:
         child pat            : CPat 
         child expr           : CExpr 
         visit 0:
            local isStrictChain : _
            local cTrf        : _
-}
-- cata
sem_CAlt :: CAlt ->
            T_CAlt
sem_CAlt (CAlt_Alt _pat _expr) =
    (sem_CAlt_Alt (sem_CPat _pat) (sem_CExpr _expr))
-- semantic domain
type T_CAlt = ( CAlt)
sem_CAlt_Alt :: T_CPat ->
                T_CExpr ->
                T_CAlt
sem_CAlt_Alt pat_ expr_ =
    (case (False) of
     { _isStrictChain ->
     (case (_isStrictChain) of
      { _exprOisStrictChain ->
      (case (expr_ _exprOisStrictChain) of
       { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
           (case (pat_) of
            { ( _patIcTrf) ->
                (case (CAlt_Alt _patIcTrf _exprIcTrf) of
                 { _cTrf ->
                 (case (_cTrf) of
                  { _lhsOcTrf ->
                  ( _lhsOcTrf) }) }) }) }) }) })
-- CAltL -------------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CAltL 
   alternatives:
      alternative Cons:
         child hd             : CAlt 
         child tl             : CAltL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CAltL :: CAltL ->
             T_CAltL
sem_CAltL list =
    (Prelude.foldr sem_CAltL_Cons sem_CAltL_Nil (Prelude.map sem_CAlt list))
-- semantic domain
type T_CAltL = ( CAltL)
sem_CAltL_Cons :: T_CAlt ->
                  T_CAltL ->
                  T_CAltL
sem_CAltL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CAltL_Nil :: T_CAltL
sem_CAltL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CBind -------------------------------------------------------
{-
   visit 0:
      chained attribute:
         isStrictChain        : Bool
      synthesized attributes:
         binds                : Seq.Seq CBind
         cTrf                 : CBind 
   alternatives:
      alternative Bind:
         child nm             : {HsName}
         child bindAspects    : CBoundL 
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CBind :: CBind ->
             T_CBind
sem_CBind (CBind_Bind _nm _bindAspects) =
    (sem_CBind_Bind _nm (sem_CBoundL _bindAspects))
-- semantic domain
type T_CBind = Bool ->
               ( (Seq.Seq CBind),CBind,Bool)
sem_CBind_Bind :: HsName ->
                  T_CBoundL ->
                  T_CBind
sem_CBind_Bind nm_ bindAspects_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _bindAspectsOisStrictChain ->
          (case (bindAspects_ _bindAspectsOisStrictChain) of
           { ( _bindAspectsIaspLiftL,_bindAspectsIcTrf,_bindAspectsIhasNonPlainBinds,_bindAspectsIisStrictChain) ->
               (case (CBind_Bind nm_ _bindAspectsIcTrf) of
                { _cTrf ->
                (case (case _bindAspectsIaspLiftL of
                         [(flatBinds,flatExpr)] | not _bindAspectsIhasNonPlainBinds
                           -> flatBinds `Seq.union` Seq.singleton (acoreBind1Cat CBindCateg_Strict nm_ flatExpr)
                         _ -> Seq.singleton _cTrf) of
                 { _lhsObinds ->
                 (case (_cTrf) of
                  { _lhsOcTrf ->
                  (case (_bindAspectsIisStrictChain) of
                   { _lhsOisStrictChain ->
                   ( _lhsObinds,_lhsOcTrf,_lhsOisStrictChain) }) }) }) }) }) }))
-- CBindAnn ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CBindAnn 
   alternatives:
      alternative Coe:
         child coe            : {()}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CBindAnn :: CBindAnn ->
                T_CBindAnn
sem_CBindAnn (CBindAnn_Coe _coe) =
    (sem_CBindAnn_Coe _coe)
-- semantic domain
type T_CBindAnn = ( CBindAnn)
sem_CBindAnn_Coe :: (()) ->
                    T_CBindAnn
sem_CBindAnn_Coe coe_ =
    (case (CBindAnn_Coe coe_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CBindAnnL ---------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CBindAnnL 
   alternatives:
      alternative Cons:
         child hd             : CBindAnn 
         child tl             : CBindAnnL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CBindAnnL :: CBindAnnL ->
                 T_CBindAnnL
sem_CBindAnnL list =
    (Prelude.foldr sem_CBindAnnL_Cons sem_CBindAnnL_Nil (Prelude.map sem_CBindAnn list))
-- semantic domain
type T_CBindAnnL = ( CBindAnnL)
sem_CBindAnnL_Cons :: T_CBindAnn ->
                      T_CBindAnnL ->
                      T_CBindAnnL
sem_CBindAnnL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CBindAnnL_Nil :: T_CBindAnnL
sem_CBindAnnL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CBindL ------------------------------------------------------
{-
   visit 0:
      chained attribute:
         isStrictChain        : Bool
      synthesized attributes:
         binds                : Seq.Seq CBind
         cTrf                 : CBindL 
   alternatives:
      alternative Cons:
         child hd             : CBind 
         child tl             : CBindL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CBindL :: CBindL ->
              T_CBindL
sem_CBindL list =
    (Prelude.foldr sem_CBindL_Cons sem_CBindL_Nil (Prelude.map sem_CBind list))
-- semantic domain
type T_CBindL = Bool ->
                ( (Seq.Seq CBind),CBindL,Bool)
sem_CBindL_Cons :: T_CBind ->
                   T_CBindL ->
                   T_CBindL
sem_CBindL_Cons hd_ tl_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _hdOisStrictChain ->
          (case (hd_ _hdOisStrictChain) of
           { ( _hdIbinds,_hdIcTrf,_hdIisStrictChain) ->
               (case (_hdIisStrictChain) of
                { _tlOisStrictChain ->
                (case (tl_ _tlOisStrictChain) of
                 { ( _tlIbinds,_tlIcTrf,_tlIisStrictChain) ->
                     (case (_hdIbinds `Seq.union` _tlIbinds) of
                      { _lhsObinds ->
                      (case ((:) _hdIcTrf _tlIcTrf) of
                       { _cTrf ->
                       (case (_cTrf) of
                        { _lhsOcTrf ->
                        (case (_tlIisStrictChain) of
                         { _lhsOisStrictChain ->
                         ( _lhsObinds,_lhsOcTrf,_lhsOisStrictChain) }) }) }) }) }) }) }) }))
sem_CBindL_Nil :: T_CBindL
sem_CBindL_Nil =
    (\ _lhsIisStrictChain ->
         (case (Seq.empty) of
          { _lhsObinds ->
          (case ([]) of
           { _cTrf ->
           (case (_cTrf) of
            { _lhsOcTrf ->
            (case (_lhsIisStrictChain) of
             { _lhsOisStrictChain ->
             ( _lhsObinds,_lhsOcTrf,_lhsOisStrictChain) }) }) }) }))
-- CBound ------------------------------------------------------
{-
   visit 0:
      chained attribute:
         isStrictChain        : Bool
      synthesized attributes:
         aspLiftL             : [Lift]
         cTrf                 : CBound 
         hasNonPlainBinds     : Bool
   alternatives:
      alternative Bind:
         child expr           : CExpr 
         visit 0:
            local cTrf        : _
      alternative Val:
         child aspectKeyS     : {ACoreBindAspectKeyS}
         child mlev           : {MetaLev}
         child lbl            : {CLbl}
         child expr           : CExpr 
         visit 0:
            local cTrf        : _
      alternative Ty:
         child aspectKeyS     : {ACoreBindAspectKeyS}
         child ty             : {Ty}
         visit 0:
            local cTrf        : _
      alternative FFE:
         child callconv       : {FFIWay}
         child expEnt         : {ForeignEnt}
         child expr           : CExpr 
         child ty             : {Ty}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CBound :: CBound ->
              T_CBound
sem_CBound (CBound_Bind _expr) =
    (sem_CBound_Bind (sem_CExpr _expr))
sem_CBound (CBound_Val _aspectKeyS _mlev _lbl _expr) =
    (sem_CBound_Val _aspectKeyS _mlev _lbl (sem_CExpr _expr))
sem_CBound (CBound_Ty _aspectKeyS _ty) =
    (sem_CBound_Ty _aspectKeyS _ty)
sem_CBound (CBound_FFE _callconv _expEnt _expr _ty) =
    (sem_CBound_FFE _callconv _expEnt (sem_CExpr _expr) _ty)
-- semantic domain
type T_CBound = Bool ->
                ( ([Lift]),CBound,Bool,Bool)
sem_CBound_Bind :: T_CExpr ->
                   T_CBound
sem_CBound_Bind expr_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _exprOisStrictChain ->
          (case (expr_ _exprOisStrictChain) of
           { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
               (case (maybe [] (:[]) _exprImbLift) of
                { _lhsOaspLiftL ->
                (case (CBound_Bind _exprIcTrf) of
                 { _cTrf ->
                 (case (_cTrf) of
                  { _lhsOcTrf ->
                  (case (False) of
                   { _lhsOhasNonPlainBinds ->
                   (case (_exprIisStrictChain) of
                    { _lhsOisStrictChain ->
                    ( _lhsOaspLiftL,_lhsOcTrf,_lhsOhasNonPlainBinds,_lhsOisStrictChain) }) }) }) }) }) }) }))
sem_CBound_Val :: ACoreBindAspectKeyS ->
                  MetaLev ->
                  CLbl ->
                  T_CExpr ->
                  T_CBound
sem_CBound_Val aspectKeyS_ mlev_ lbl_ expr_ =
    (\ _lhsIisStrictChain ->
         (case ([]) of
          { _lhsOaspLiftL ->
          (case (_lhsIisStrictChain) of
           { _exprOisStrictChain ->
           (case (expr_ _exprOisStrictChain) of
            { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
                (case (CBound_Val aspectKeyS_ mlev_ lbl_ _exprIcTrf) of
                 { _cTrf ->
                 (case (_cTrf) of
                  { _lhsOcTrf ->
                  (case (True) of
                   { _lhsOhasNonPlainBinds ->
                   (case (_exprIisStrictChain) of
                    { _lhsOisStrictChain ->
                    ( _lhsOaspLiftL,_lhsOcTrf,_lhsOhasNonPlainBinds,_lhsOisStrictChain) }) }) }) }) }) }) }))
sem_CBound_Ty :: ACoreBindAspectKeyS ->
                 Ty ->
                 T_CBound
sem_CBound_Ty aspectKeyS_ ty_ =
    (\ _lhsIisStrictChain ->
         (case ([]) of
          { _lhsOaspLiftL ->
          (case (CBound_Ty aspectKeyS_ ty_) of
           { _cTrf ->
           (case (_cTrf) of
            { _lhsOcTrf ->
            (case (True) of
             { _lhsOhasNonPlainBinds ->
             (case (_lhsIisStrictChain) of
              { _lhsOisStrictChain ->
              ( _lhsOaspLiftL,_lhsOcTrf,_lhsOhasNonPlainBinds,_lhsOisStrictChain) }) }) }) }) }))
sem_CBound_FFE :: FFIWay ->
                  ForeignEnt ->
                  T_CExpr ->
                  Ty ->
                  T_CBound
sem_CBound_FFE callconv_ expEnt_ expr_ ty_ =
    (\ _lhsIisStrictChain ->
         (case ([]) of
          { _lhsOaspLiftL ->
          (case (_lhsIisStrictChain) of
           { _exprOisStrictChain ->
           (case (expr_ _exprOisStrictChain) of
            { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
                (case (CBound_FFE callconv_ expEnt_ _exprIcTrf ty_) of
                 { _cTrf ->
                 (case (_cTrf) of
                  { _lhsOcTrf ->
                  (case (True) of
                   { _lhsOhasNonPlainBinds ->
                   (case (_exprIisStrictChain) of
                    { _lhsOisStrictChain ->
                    ( _lhsOaspLiftL,_lhsOcTrf,_lhsOhasNonPlainBinds,_lhsOisStrictChain) }) }) }) }) }) }) }))
-- CBoundL -----------------------------------------------------
{-
   visit 0:
      chained attribute:
         isStrictChain        : Bool
      synthesized attributes:
         aspLiftL             : [Lift]
         cTrf                 : CBoundL 
         hasNonPlainBinds     : Bool
   alternatives:
      alternative Cons:
         child hd             : CBound 
         child tl             : CBoundL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CBoundL :: CBoundL ->
               T_CBoundL
sem_CBoundL list =
    (Prelude.foldr sem_CBoundL_Cons sem_CBoundL_Nil (Prelude.map sem_CBound list))
-- semantic domain
type T_CBoundL = Bool ->
                 ( ([Lift]),CBoundL,Bool,Bool)
sem_CBoundL_Cons :: T_CBound ->
                    T_CBoundL ->
                    T_CBoundL
sem_CBoundL_Cons hd_ tl_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _hdOisStrictChain ->
          (case (hd_ _hdOisStrictChain) of
           { ( _hdIaspLiftL,_hdIcTrf,_hdIhasNonPlainBinds,_hdIisStrictChain) ->
               (case (_hdIisStrictChain) of
                { _tlOisStrictChain ->
                (case (tl_ _tlOisStrictChain) of
                 { ( _tlIaspLiftL,_tlIcTrf,_tlIhasNonPlainBinds,_tlIisStrictChain) ->
                     (case (_hdIaspLiftL ++ _tlIaspLiftL) of
                      { _lhsOaspLiftL ->
                      (case ((:) _hdIcTrf _tlIcTrf) of
                       { _cTrf ->
                       (case (_cTrf) of
                        { _lhsOcTrf ->
                        (case (_hdIhasNonPlainBinds || _tlIhasNonPlainBinds) of
                         { _lhsOhasNonPlainBinds ->
                         (case (_tlIisStrictChain) of
                          { _lhsOisStrictChain ->
                          ( _lhsOaspLiftL,_lhsOcTrf,_lhsOhasNonPlainBinds,_lhsOisStrictChain) }) }) }) }) }) }) }) }) }))
sem_CBoundL_Nil :: T_CBoundL
sem_CBoundL_Nil =
    (\ _lhsIisStrictChain ->
         (case ([]) of
          { _lhsOaspLiftL ->
          (case ([]) of
           { _cTrf ->
           (case (_cTrf) of
            { _lhsOcTrf ->
            (case (False) of
             { _lhsOhasNonPlainBinds ->
             (case (_lhsIisStrictChain) of
              { _lhsOisStrictChain ->
              ( _lhsOaspLiftL,_lhsOcTrf,_lhsOhasNonPlainBinds,_lhsOisStrictChain) }) }) }) }) }))
-- CDataCon ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CDataCon 
   alternatives:
      alternative Con:
         child conNm          : {HsName}
         child tagNr          : {Int}
         child arity          : {Int}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CDataCon :: CDataCon ->
                T_CDataCon
sem_CDataCon (CDataCon_Con _conNm _tagNr _arity) =
    (sem_CDataCon_Con _conNm _tagNr _arity)
-- semantic domain
type T_CDataCon = ( CDataCon)
sem_CDataCon_Con :: HsName ->
                    Int ->
                    Int ->
                    T_CDataCon
sem_CDataCon_Con conNm_ tagNr_ arity_ =
    (case (CDataCon_Con conNm_ tagNr_ arity_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CDataConL ---------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CDataConL 
   alternatives:
      alternative Cons:
         child hd             : CDataCon 
         child tl             : CDataConL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CDataConL :: CDataConL ->
                 T_CDataConL
sem_CDataConL list =
    (Prelude.foldr sem_CDataConL_Cons sem_CDataConL_Nil (Prelude.map sem_CDataCon list))
-- semantic domain
type T_CDataConL = ( CDataConL)
sem_CDataConL_Cons :: T_CDataCon ->
                      T_CDataConL ->
                      T_CDataConL
sem_CDataConL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CDataConL_Nil :: T_CDataConL
sem_CDataConL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CDeclMeta ---------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CDeclMeta 
   alternatives:
      alternative Data:
         child tyNm           : {HsName}
         child dataCons       : CDataConL 
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CDeclMeta :: CDeclMeta ->
                 T_CDeclMeta
sem_CDeclMeta (CDeclMeta_Data _tyNm _dataCons) =
    (sem_CDeclMeta_Data _tyNm (sem_CDataConL _dataCons))
-- semantic domain
type T_CDeclMeta = ( CDeclMeta)
sem_CDeclMeta_Data :: HsName ->
                      T_CDataConL ->
                      T_CDeclMeta
sem_CDeclMeta_Data tyNm_ dataCons_ =
    (case (dataCons_) of
     { ( _dataConsIcTrf) ->
         (case (CDeclMeta_Data tyNm_ _dataConsIcTrf) of
          { _cTrf ->
          (case (_cTrf) of
           { _lhsOcTrf ->
           ( _lhsOcTrf) }) }) })
-- CDeclMetaL --------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CDeclMetaL 
   alternatives:
      alternative Cons:
         child hd             : CDeclMeta 
         child tl             : CDeclMetaL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CDeclMetaL :: CDeclMetaL ->
                  T_CDeclMetaL
sem_CDeclMetaL list =
    (Prelude.foldr sem_CDeclMetaL_Cons sem_CDeclMetaL_Nil (Prelude.map sem_CDeclMeta list))
-- semantic domain
type T_CDeclMetaL = ( CDeclMetaL)
sem_CDeclMetaL_Cons :: T_CDeclMeta ->
                       T_CDeclMetaL ->
                       T_CDeclMetaL
sem_CDeclMetaL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CDeclMetaL_Nil :: T_CDeclMetaL
sem_CDeclMetaL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CExport -----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CExport 
   alternatives:
      alternative Export:
         child nm             : {HsName}
         visit 0:
            local cTrf        : _
      alternative ExportData:
         child nm             : {HsName}
         child mbConNmL       : {Maybe [HsName]}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CExport :: CExport ->
               T_CExport
sem_CExport (CExport_Export _nm) =
    (sem_CExport_Export _nm)
sem_CExport (CExport_ExportData _nm _mbConNmL) =
    (sem_CExport_ExportData _nm _mbConNmL)
-- semantic domain
type T_CExport = ( CExport)
sem_CExport_Export :: HsName ->
                      T_CExport
sem_CExport_Export nm_ =
    (case (CExport_Export nm_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
sem_CExport_ExportData :: HsName ->
                          (Maybe [HsName]) ->
                          T_CExport
sem_CExport_ExportData nm_ mbConNmL_ =
    (case (CExport_ExportData nm_ mbConNmL_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CExportL ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CExportL 
   alternatives:
      alternative Cons:
         child hd             : CExport 
         child tl             : CExportL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CExportL :: CExportL ->
                T_CExportL
sem_CExportL list =
    (Prelude.foldr sem_CExportL_Cons sem_CExportL_Nil (Prelude.map sem_CExport list))
-- semantic domain
type T_CExportL = ( CExportL)
sem_CExportL_Cons :: T_CExport ->
                     T_CExportL ->
                     T_CExportL
sem_CExportL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CExportL_Nil :: T_CExportL
sem_CExportL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CExpr -------------------------------------------------------
{-
   visit 0:
      chained attribute:
         isStrictChain        : Bool
      synthesized attributes:
         binds                : Seq.Seq CBind
         cTrf                 : CExpr 
         flatExpr             : CExpr 
         mbLift               : MbLift
   alternatives:
      alternative Var:
         child ref            : {ACoreBindRef}
         visit 0:
            local cTrf        : _
            local _tup1       : _
      alternative Int:
         child int            : {Int}
         visit 0:
            local cTrf        : _
            local _tup2       : _
      alternative Char:
         child char           : {Char}
         visit 0:
            local cTrf        : _
            local _tup3       : _
      alternative String:
         child str            : {String}
         visit 0:
            local cTrf        : _
            local _tup4       : _
      alternative Integer:
         child integer        : {Integer}
         visit 0:
            local cTrf        : _
            local _tup5       : _
      alternative Tup:
         child tag            : {CTag}
         visit 0:
            local cTrf        : _
            local _tup6       : _
      alternative Let:
         child categ          : {CBindCateg}
         child binds          : CBindL 
         child body           : CExpr 
         visit 0:
            local isStrictChain : _
            local cTrf        : _
            local letbinds    : _
            local isLaterInChain : _
            local _tup7       : _
            local isFirstInChain : _
      alternative App:
         child func           : CExpr 
         child arg            : CBound 
         visit 0:
            local cTrf        : _
            local _tup8       : _
      alternative Lam:
         child bind           : CBind 
         child body           : CExpr 
         visit 0:
            local cTrf        : _
            local _tup9       : _
      alternative Case:
         child expr           : CExpr 
         child alts           : CAltL 
         child dflt           : CExpr 
         visit 0:
            local cTrf        : _
            local _tup10      : _
      alternative CaseAltFail:
         child failReason     : {CaseAltFailReason}
         child errorExpr      : CExpr 
         visit 0:
            local cTrf        : _
            local _tup11      : _
      alternative TupDel:
         child expr           : CExpr 
         child tag            : {CTag}
         child nm             : {HsName}
         child offset         : CExpr 
         visit 0:
            local cTrf        : _
            local _tup12      : _
      alternative TupIns:
         child expr           : CExpr 
         child tag            : {CTag}
         child nm             : {HsName}
         child offset         : CExpr 
         child fldExpr        : CExpr 
         visit 0:
            local cTrf        : _
            local _tup13      : _
      alternative TupUpd:
         child expr           : CExpr 
         child tag            : {CTag}
         child nm             : {HsName}
         child offset         : CExpr 
         child fldExpr        : CExpr 
         visit 0:
            local cTrf        : _
            local _tup14      : _
      alternative FFI:
         child callconv       : {FFIWay}
         child safety         : {String}
         child impEnt         : {ForeignEnt}
         child ty             : {Ty}
         visit 0:
            local cTrf        : _
            local _tup15      : _
      alternative Dbg:
         child info           : {String}
         visit 0:
            local cTrf        : _
            local _tup16      : _
      alternative Hole:
         child uid            : {UID}
         visit 0:
            local cTrf        : _
            local _tup17      : _
      alternative HoleLet:
         child bindsUid       : {UID}
         child body           : CExpr 
         visit 0:
            local cTrf        : _
            local _tup18      : _
      alternative CoeArg:
         visit 0:
            local cTrf        : _
            local _tup19      : _
      alternative ImplsApp:
         child func           : CExpr 
         child uid            : {ImplsVarId}
         visit 0:
            local cTrf        : _
            local _tup20      : _
      alternative ImplsLam:
         child uid            : {ImplsVarId}
         child body           : CExpr 
         visit 0:
            local cTrf        : _
            local _tup21      : _
      alternative Ann:
         child ann            : CExprAnn 
         child expr           : CExpr 
         visit 0:
            local cTrf        : _
            local _tup22      : _
-}
-- cata
sem_CExpr :: CExpr ->
             T_CExpr
sem_CExpr (CExpr_Var _ref) =
    (sem_CExpr_Var _ref)
sem_CExpr (CExpr_Int _int) =
    (sem_CExpr_Int _int)
sem_CExpr (CExpr_Char _char) =
    (sem_CExpr_Char _char)
sem_CExpr (CExpr_String _str) =
    (sem_CExpr_String _str)
sem_CExpr (CExpr_Integer _integer) =
    (sem_CExpr_Integer _integer)
sem_CExpr (CExpr_Tup _tag) =
    (sem_CExpr_Tup _tag)
sem_CExpr (CExpr_Let _categ _binds _body) =
    (sem_CExpr_Let _categ (sem_CBindL _binds) (sem_CExpr _body))
sem_CExpr (CExpr_App _func _arg) =
    (sem_CExpr_App (sem_CExpr _func) (sem_CBound _arg))
sem_CExpr (CExpr_Lam _bind _body) =
    (sem_CExpr_Lam (sem_CBind _bind) (sem_CExpr _body))
sem_CExpr (CExpr_Case _expr _alts _dflt) =
    (sem_CExpr_Case (sem_CExpr _expr) (sem_CAltL _alts) (sem_CExpr _dflt))
sem_CExpr (CExpr_CaseAltFail _failReason _errorExpr) =
    (sem_CExpr_CaseAltFail _failReason (sem_CExpr _errorExpr))
sem_CExpr (CExpr_TupDel _expr _tag _nm _offset) =
    (sem_CExpr_TupDel (sem_CExpr _expr) _tag _nm (sem_CExpr _offset))
sem_CExpr (CExpr_TupIns _expr _tag _nm _offset _fldExpr) =
    (sem_CExpr_TupIns (sem_CExpr _expr) _tag _nm (sem_CExpr _offset) (sem_CExpr _fldExpr))
sem_CExpr (CExpr_TupUpd _expr _tag _nm _offset _fldExpr) =
    (sem_CExpr_TupUpd (sem_CExpr _expr) _tag _nm (sem_CExpr _offset) (sem_CExpr _fldExpr))
sem_CExpr (CExpr_FFI _callconv _safety _impEnt _ty) =
    (sem_CExpr_FFI _callconv _safety _impEnt _ty)
sem_CExpr (CExpr_Dbg _info) =
    (sem_CExpr_Dbg _info)
sem_CExpr (CExpr_Hole _uid) =
    (sem_CExpr_Hole _uid)
sem_CExpr (CExpr_HoleLet _bindsUid _body) =
    (sem_CExpr_HoleLet _bindsUid (sem_CExpr _body))
sem_CExpr (CExpr_CoeArg) =
    (sem_CExpr_CoeArg)
sem_CExpr (CExpr_ImplsApp _func _uid) =
    (sem_CExpr_ImplsApp (sem_CExpr _func) _uid)
sem_CExpr (CExpr_ImplsLam _uid _body) =
    (sem_CExpr_ImplsLam _uid (sem_CExpr _body))
sem_CExpr (CExpr_Ann _ann _expr) =
    (sem_CExpr_Ann (sem_CExprAnn _ann) (sem_CExpr _expr))
-- semantic domain
type T_CExpr = Bool ->
               ( (Seq.Seq CBind),CExpr,CExpr,Bool,MbLift)
sem_CExpr_Var :: ACoreBindRef ->
                 T_CExpr
sem_CExpr_Var ref_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Var ref_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup1 ->
           (case (__tup1) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup1) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Int :: Int ->
                 T_CExpr
sem_CExpr_Int int_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Int int_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup2 ->
           (case (__tup2) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup2) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Char :: Char ->
                  T_CExpr
sem_CExpr_Char char_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Char char_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup3 ->
           (case (__tup3) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup3) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_String :: String ->
                    T_CExpr
sem_CExpr_String str_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_String str_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup4 ->
           (case (__tup4) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup4) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Integer :: Integer ->
                     T_CExpr
sem_CExpr_Integer integer_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Integer integer_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup5 ->
           (case (__tup5) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup5) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Tup :: CTag ->
                 T_CExpr
sem_CExpr_Tup tag_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Tup tag_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup6 ->
           (case (__tup6) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup6) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Let :: CBindCateg ->
                 T_CBindL ->
                 T_CExpr ->
                 T_CExpr
sem_CExpr_Let categ_ binds_ body_ =
    (\ _lhsIisStrictChain ->
         (case (categ_ == CBindCateg_Strict) of
          { _isStrictChain ->
          (case (_isStrictChain) of
           { _bindsOisStrictChain ->
           (case (binds_ _bindsOisStrictChain) of
            { ( _bindsIbinds,_bindsIcTrf,_bindsIisStrictChain) ->
                (case (_isStrictChain && _bindsIisStrictChain) of
                 { _bodyOisStrictChain ->
                 (case (body_ _bodyOisStrictChain) of
                  { ( _bodyIbinds,_bodyIcTrf,_bodyIflatExpr,_bodyIisStrictChain,_bodyImbLift) ->
                      (case (CExpr_Let categ_ _bindsIcTrf _bodyIcTrf) of
                       { _cTrf ->
                       (case (_bindsIbinds `Seq.union` _bodyIbinds) of
                        { _letbinds ->
                        (case (_isStrictChain &&     _lhsIisStrictChain) of
                         { _isLaterInChain ->
                         (case (if _isLaterInChain
                                then (_letbinds,_bodyIflatExpr)
                                else (Seq.empty,_cTrf)) of
                          { __tup7 ->
                          (case (__tup7) of
                           { (_lhsObinds,_) ->
                           (case (_isStrictChain && not _lhsIisStrictChain) of
                            { _isFirstInChain ->
                            (case (if _isFirstInChain
                                   then foldr (\b e -> CExpr_Let categ_ [b] e) _bodyIflatExpr $ Seq.toList _letbinds
                                   else _cTrf) of
                             { _lhsOcTrf ->
                             (case (__tup7) of
                              { (_,_lhsOflatExpr) ->
                              (case (_isStrictChain && _bodyIisStrictChain) of
                               { _lhsOisStrictChain ->
                               (case (if _isLaterInChain
                                      then Just (_letbinds, _bodyIflatExpr)
                                      else Nothing) of
                                { _lhsOmbLift ->
                                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_App :: T_CExpr ->
                 T_CBound ->
                 T_CExpr
sem_CExpr_App func_ arg_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _funcOisStrictChain ->
          (case (func_ _funcOisStrictChain) of
           { ( _funcIbinds,_funcIcTrf,_funcIflatExpr,_funcIisStrictChain,_funcImbLift) ->
               (case (_funcIisStrictChain) of
                { _argOisStrictChain ->
                (case (arg_ _argOisStrictChain) of
                 { ( _argIaspLiftL,_argIcTrf,_argIhasNonPlainBinds,_argIisStrictChain) ->
                     (case (CExpr_App _funcIcTrf _argIcTrf) of
                      { _cTrf ->
                      (case ((Seq.empty,_cTrf)) of
                       { __tup8 ->
                       (case (__tup8) of
                        { (_lhsObinds,_) ->
                        (case (_cTrf) of
                         { _lhsOcTrf ->
                         (case (__tup8) of
                          { (_,_lhsOflatExpr) ->
                          (case (_lhsIisStrictChain) of
                           { _lhsOisStrictChain ->
                           (case (Nothing) of
                            { _lhsOmbLift ->
                            ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_Lam :: T_CBind ->
                 T_CExpr ->
                 T_CExpr
sem_CExpr_Lam bind_ body_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _bindOisStrictChain ->
          (case (bind_ _bindOisStrictChain) of
           { ( _bindIbinds,_bindIcTrf,_bindIisStrictChain) ->
               (case (_bindIisStrictChain) of
                { _bodyOisStrictChain ->
                (case (body_ _bodyOisStrictChain) of
                 { ( _bodyIbinds,_bodyIcTrf,_bodyIflatExpr,_bodyIisStrictChain,_bodyImbLift) ->
                     (case (CExpr_Lam _bindIcTrf _bodyIcTrf) of
                      { _cTrf ->
                      (case ((Seq.empty,_cTrf)) of
                       { __tup9 ->
                       (case (__tup9) of
                        { (_lhsObinds,_) ->
                        (case (_cTrf) of
                         { _lhsOcTrf ->
                         (case (__tup9) of
                          { (_,_lhsOflatExpr) ->
                          (case (_lhsIisStrictChain) of
                           { _lhsOisStrictChain ->
                           (case (Nothing) of
                            { _lhsOmbLift ->
                            ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_Case :: T_CExpr ->
                  T_CAltL ->
                  T_CExpr ->
                  T_CExpr
sem_CExpr_Case expr_ alts_ dflt_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _exprOisStrictChain ->
          (case (expr_ _exprOisStrictChain) of
           { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
               (case (_exprIisStrictChain) of
                { _dfltOisStrictChain ->
                (case (dflt_ _dfltOisStrictChain) of
                 { ( _dfltIbinds,_dfltIcTrf,_dfltIflatExpr,_dfltIisStrictChain,_dfltImbLift) ->
                     (case (alts_) of
                      { ( _altsIcTrf) ->
                          (case (CExpr_Case _exprIcTrf _altsIcTrf _dfltIcTrf) of
                           { _cTrf ->
                           (case ((Seq.empty,_cTrf)) of
                            { __tup10 ->
                            (case (__tup10) of
                             { (_lhsObinds,_) ->
                             (case (_cTrf) of
                              { _lhsOcTrf ->
                              (case (__tup10) of
                               { (_,_lhsOflatExpr) ->
                               (case (_lhsIisStrictChain) of
                                { _lhsOisStrictChain ->
                                (case (Nothing) of
                                 { _lhsOmbLift ->
                                 ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_CaseAltFail :: CaseAltFailReason ->
                         T_CExpr ->
                         T_CExpr
sem_CExpr_CaseAltFail failReason_ errorExpr_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _errorExprOisStrictChain ->
          (case (errorExpr_ _errorExprOisStrictChain) of
           { ( _errorExprIbinds,_errorExprIcTrf,_errorExprIflatExpr,_errorExprIisStrictChain,_errorExprImbLift) ->
               (case (CExpr_CaseAltFail failReason_ _errorExprIcTrf) of
                { _cTrf ->
                (case ((Seq.empty,_cTrf)) of
                 { __tup11 ->
                 (case (__tup11) of
                  { (_lhsObinds,_) ->
                  (case (_cTrf) of
                   { _lhsOcTrf ->
                   (case (__tup11) of
                    { (_,_lhsOflatExpr) ->
                    (case (_lhsIisStrictChain) of
                     { _lhsOisStrictChain ->
                     (case (Nothing) of
                      { _lhsOmbLift ->
                      ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }))
sem_CExpr_TupDel :: T_CExpr ->
                    CTag ->
                    HsName ->
                    T_CExpr ->
                    T_CExpr
sem_CExpr_TupDel expr_ tag_ nm_ offset_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _exprOisStrictChain ->
          (case (expr_ _exprOisStrictChain) of
           { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
               (case (_exprIisStrictChain) of
                { _offsetOisStrictChain ->
                (case (offset_ _offsetOisStrictChain) of
                 { ( _offsetIbinds,_offsetIcTrf,_offsetIflatExpr,_offsetIisStrictChain,_offsetImbLift) ->
                     (case (CExpr_TupDel _exprIcTrf tag_ nm_ _offsetIcTrf) of
                      { _cTrf ->
                      (case ((Seq.empty,_cTrf)) of
                       { __tup12 ->
                       (case (__tup12) of
                        { (_lhsObinds,_) ->
                        (case (_cTrf) of
                         { _lhsOcTrf ->
                         (case (__tup12) of
                          { (_,_lhsOflatExpr) ->
                          (case (_lhsIisStrictChain) of
                           { _lhsOisStrictChain ->
                           (case (Nothing) of
                            { _lhsOmbLift ->
                            ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_TupIns :: T_CExpr ->
                    CTag ->
                    HsName ->
                    T_CExpr ->
                    T_CExpr ->
                    T_CExpr
sem_CExpr_TupIns expr_ tag_ nm_ offset_ fldExpr_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _exprOisStrictChain ->
          (case (expr_ _exprOisStrictChain) of
           { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
               (case (_exprIisStrictChain) of
                { _offsetOisStrictChain ->
                (case (offset_ _offsetOisStrictChain) of
                 { ( _offsetIbinds,_offsetIcTrf,_offsetIflatExpr,_offsetIisStrictChain,_offsetImbLift) ->
                     (case (_offsetIisStrictChain) of
                      { _fldExprOisStrictChain ->
                      (case (fldExpr_ _fldExprOisStrictChain) of
                       { ( _fldExprIbinds,_fldExprIcTrf,_fldExprIflatExpr,_fldExprIisStrictChain,_fldExprImbLift) ->
                           (case (CExpr_TupIns _exprIcTrf tag_ nm_ _offsetIcTrf _fldExprIcTrf) of
                            { _cTrf ->
                            (case ((Seq.empty,_cTrf)) of
                             { __tup13 ->
                             (case (__tup13) of
                              { (_lhsObinds,_) ->
                              (case (_cTrf) of
                               { _lhsOcTrf ->
                               (case (__tup13) of
                                { (_,_lhsOflatExpr) ->
                                (case (_lhsIisStrictChain) of
                                 { _lhsOisStrictChain ->
                                 (case (Nothing) of
                                  { _lhsOmbLift ->
                                  ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_TupUpd :: T_CExpr ->
                    CTag ->
                    HsName ->
                    T_CExpr ->
                    T_CExpr ->
                    T_CExpr
sem_CExpr_TupUpd expr_ tag_ nm_ offset_ fldExpr_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _exprOisStrictChain ->
          (case (expr_ _exprOisStrictChain) of
           { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
               (case (_exprIisStrictChain) of
                { _offsetOisStrictChain ->
                (case (offset_ _offsetOisStrictChain) of
                 { ( _offsetIbinds,_offsetIcTrf,_offsetIflatExpr,_offsetIisStrictChain,_offsetImbLift) ->
                     (case (_offsetIisStrictChain) of
                      { _fldExprOisStrictChain ->
                      (case (fldExpr_ _fldExprOisStrictChain) of
                       { ( _fldExprIbinds,_fldExprIcTrf,_fldExprIflatExpr,_fldExprIisStrictChain,_fldExprImbLift) ->
                           (case (CExpr_TupUpd _exprIcTrf tag_ nm_ _offsetIcTrf _fldExprIcTrf) of
                            { _cTrf ->
                            (case ((Seq.empty,_cTrf)) of
                             { __tup14 ->
                             (case (__tup14) of
                              { (_lhsObinds,_) ->
                              (case (_cTrf) of
                               { _lhsOcTrf ->
                               (case (__tup14) of
                                { (_,_lhsOflatExpr) ->
                                (case (_lhsIisStrictChain) of
                                 { _lhsOisStrictChain ->
                                 (case (Nothing) of
                                  { _lhsOmbLift ->
                                  ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }) }) }) }))
sem_CExpr_FFI :: FFIWay ->
                 String ->
                 ForeignEnt ->
                 Ty ->
                 T_CExpr
sem_CExpr_FFI callconv_ safety_ impEnt_ ty_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_FFI callconv_ safety_ impEnt_ ty_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup15 ->
           (case (__tup15) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup15) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Dbg :: String ->
                 T_CExpr
sem_CExpr_Dbg info_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Dbg info_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup16 ->
           (case (__tup16) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup16) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_Hole :: UID ->
                  T_CExpr
sem_CExpr_Hole uid_ =
    (\ _lhsIisStrictChain ->
         (case (CExpr_Hole uid_) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup17 ->
           (case (__tup17) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup17) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_HoleLet :: UID ->
                     T_CExpr ->
                     T_CExpr
sem_CExpr_HoleLet bindsUid_ body_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _bodyOisStrictChain ->
          (case (body_ _bodyOisStrictChain) of
           { ( _bodyIbinds,_bodyIcTrf,_bodyIflatExpr,_bodyIisStrictChain,_bodyImbLift) ->
               (case (CExpr_HoleLet bindsUid_ _bodyIcTrf) of
                { _cTrf ->
                (case ((Seq.empty,_cTrf)) of
                 { __tup18 ->
                 (case (__tup18) of
                  { (_lhsObinds,_) ->
                  (case (_cTrf) of
                   { _lhsOcTrf ->
                   (case (__tup18) of
                    { (_,_lhsOflatExpr) ->
                    (case (_lhsIisStrictChain) of
                     { _lhsOisStrictChain ->
                     (case (Nothing) of
                      { _lhsOmbLift ->
                      ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }))
sem_CExpr_CoeArg :: T_CExpr
sem_CExpr_CoeArg =
    (\ _lhsIisStrictChain ->
         (case (CExpr_CoeArg) of
          { _cTrf ->
          (case ((Seq.empty,_cTrf)) of
           { __tup19 ->
           (case (__tup19) of
            { (_lhsObinds,_) ->
            (case (_cTrf) of
             { _lhsOcTrf ->
             (case (__tup19) of
              { (_,_lhsOflatExpr) ->
              (case (_lhsIisStrictChain) of
               { _lhsOisStrictChain ->
               (case (Nothing) of
                { _lhsOmbLift ->
                ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }))
sem_CExpr_ImplsApp :: T_CExpr ->
                      ImplsVarId ->
                      T_CExpr
sem_CExpr_ImplsApp func_ uid_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _funcOisStrictChain ->
          (case (func_ _funcOisStrictChain) of
           { ( _funcIbinds,_funcIcTrf,_funcIflatExpr,_funcIisStrictChain,_funcImbLift) ->
               (case (CExpr_ImplsApp _funcIcTrf uid_) of
                { _cTrf ->
                (case ((Seq.empty,_cTrf)) of
                 { __tup20 ->
                 (case (__tup20) of
                  { (_lhsObinds,_) ->
                  (case (_cTrf) of
                   { _lhsOcTrf ->
                   (case (__tup20) of
                    { (_,_lhsOflatExpr) ->
                    (case (_lhsIisStrictChain) of
                     { _lhsOisStrictChain ->
                     (case (Nothing) of
                      { _lhsOmbLift ->
                      ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }))
sem_CExpr_ImplsLam :: ImplsVarId ->
                      T_CExpr ->
                      T_CExpr
sem_CExpr_ImplsLam uid_ body_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _bodyOisStrictChain ->
          (case (body_ _bodyOisStrictChain) of
           { ( _bodyIbinds,_bodyIcTrf,_bodyIflatExpr,_bodyIisStrictChain,_bodyImbLift) ->
               (case (CExpr_ImplsLam uid_ _bodyIcTrf) of
                { _cTrf ->
                (case ((Seq.empty,_cTrf)) of
                 { __tup21 ->
                 (case (__tup21) of
                  { (_lhsObinds,_) ->
                  (case (_cTrf) of
                   { _lhsOcTrf ->
                   (case (__tup21) of
                    { (_,_lhsOflatExpr) ->
                    (case (_lhsIisStrictChain) of
                     { _lhsOisStrictChain ->
                     (case (Nothing) of
                      { _lhsOmbLift ->
                      ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }))
sem_CExpr_Ann :: T_CExprAnn ->
                 T_CExpr ->
                 T_CExpr
sem_CExpr_Ann ann_ expr_ =
    (\ _lhsIisStrictChain ->
         (case (_lhsIisStrictChain) of
          { _exprOisStrictChain ->
          (case (expr_ _exprOisStrictChain) of
           { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
               (case (ann_) of
                { ( _annIcTrf) ->
                    (case (CExpr_Ann _annIcTrf _exprIcTrf) of
                     { _cTrf ->
                     (case ((Seq.empty,_cTrf)) of
                      { __tup22 ->
                      (case (__tup22) of
                       { (_lhsObinds,_) ->
                       (case (_cTrf) of
                        { _lhsOcTrf ->
                        (case (__tup22) of
                         { (_,_lhsOflatExpr) ->
                         (case (_exprIisStrictChain) of
                          { _lhsOisStrictChain ->
                          (case (Nothing) of
                           { _lhsOmbLift ->
                           ( _lhsObinds,_lhsOcTrf,_lhsOflatExpr,_lhsOisStrictChain,_lhsOmbLift) }) }) }) }) }) }) }) }) }) }))
-- CExprAnn ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CExprAnn 
   alternatives:
      alternative Ty:
         child ty             : {Ty}
         visit 0:
            local cTrf        : _
      alternative Debug:
         child info           : {String}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CExprAnn :: CExprAnn ->
                T_CExprAnn
sem_CExprAnn (CExprAnn_Ty _ty) =
    (sem_CExprAnn_Ty _ty)
sem_CExprAnn (CExprAnn_Debug _info) =
    (sem_CExprAnn_Debug _info)
-- semantic domain
type T_CExprAnn = ( CExprAnn)
sem_CExprAnn_Ty :: Ty ->
                   T_CExprAnn
sem_CExprAnn_Ty ty_ =
    (case (CExprAnn_Ty ty_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
sem_CExprAnn_Debug :: String ->
                      T_CExprAnn
sem_CExprAnn_Debug info_ =
    (case (CExprAnn_Debug info_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CImport -----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CImport 
   alternatives:
      alternative Import:
         child nm             : {HsName}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CImport :: CImport ->
               T_CImport
sem_CImport (CImport_Import _nm) =
    (sem_CImport_Import _nm)
-- semantic domain
type T_CImport = ( CImport)
sem_CImport_Import :: HsName ->
                      T_CImport
sem_CImport_Import nm_ =
    (case (CImport_Import nm_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CImportL ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CImportL 
   alternatives:
      alternative Cons:
         child hd             : CImport 
         child tl             : CImportL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CImportL :: CImportL ->
                T_CImportL
sem_CImportL list =
    (Prelude.foldr sem_CImportL_Cons sem_CImportL_Nil (Prelude.map sem_CImport list))
-- semantic domain
type T_CImportL = ( CImportL)
sem_CImportL_Cons :: T_CImport ->
                     T_CImportL ->
                     T_CImportL
sem_CImportL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CImportL_Nil :: T_CImportL
sem_CImportL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CModule -----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CModule 
   alternatives:
      alternative Mod:
         child moduleNm       : {HsName}
         child exports        : CExportL 
         child imports        : CImportL 
         child declMetas      : CDeclMetaL 
         child expr           : CExpr 
         visit 0:
            local isStrictChain : _
            local cTrf        : _
-}
-- cata
sem_CModule :: CModule ->
               T_CModule
sem_CModule (CModule_Mod _moduleNm _exports _imports _declMetas _expr) =
    (sem_CModule_Mod _moduleNm (sem_CExportL _exports) (sem_CImportL _imports) (sem_CDeclMetaL _declMetas) (sem_CExpr _expr))
-- semantic domain
type T_CModule = ( CModule)
sem_CModule_Mod :: HsName ->
                   T_CExportL ->
                   T_CImportL ->
                   T_CDeclMetaL ->
                   T_CExpr ->
                   T_CModule
sem_CModule_Mod moduleNm_ exports_ imports_ declMetas_ expr_ =
    (case (False) of
     { _isStrictChain ->
     (case (_isStrictChain) of
      { _exprOisStrictChain ->
      (case (expr_ _exprOisStrictChain) of
       { ( _exprIbinds,_exprIcTrf,_exprIflatExpr,_exprIisStrictChain,_exprImbLift) ->
           (case (declMetas_) of
            { ( _declMetasIcTrf) ->
                (case (imports_) of
                 { ( _importsIcTrf) ->
                     (case (exports_) of
                      { ( _exportsIcTrf) ->
                          (case (CModule_Mod moduleNm_ _exportsIcTrf _importsIcTrf _declMetasIcTrf _exprIcTrf) of
                           { _cTrf ->
                           (case (_cTrf) of
                            { _lhsOcTrf ->
                            ( _lhsOcTrf) }) }) }) }) }) }) }) })
-- CPat --------------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CPat 
   alternatives:
      alternative Var:
         child pnm            : {HsName}
         visit 0:
            local cTrf        : _
      alternative Con:
         child tag            : {CTag}
         child rest           : CPatRest 
         child binds          : CPatFldL 
         visit 0:
            local cTrf        : _
      alternative Int:
         child int            : {Int}
         visit 0:
            local cTrf        : _
      alternative Char:
         child char           : {Char}
         visit 0:
            local cTrf        : _
      alternative BoolExpr:
         child cexpr          : {CExpr}
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CPat :: CPat ->
            T_CPat
sem_CPat (CPat_Var _pnm) =
    (sem_CPat_Var _pnm)
sem_CPat (CPat_Con _tag _rest _binds) =
    (sem_CPat_Con _tag (sem_CPatRest _rest) (sem_CPatFldL _binds))
sem_CPat (CPat_Int _int) =
    (sem_CPat_Int _int)
sem_CPat (CPat_Char _char) =
    (sem_CPat_Char _char)
sem_CPat (CPat_BoolExpr _cexpr) =
    (sem_CPat_BoolExpr _cexpr)
-- semantic domain
type T_CPat = ( CPat)
sem_CPat_Var :: HsName ->
                T_CPat
sem_CPat_Var pnm_ =
    (case (CPat_Var pnm_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
sem_CPat_Con :: CTag ->
                T_CPatRest ->
                T_CPatFldL ->
                T_CPat
sem_CPat_Con tag_ rest_ binds_ =
    (case (binds_) of
     { ( _bindsIcTrf) ->
         (case (rest_) of
          { ( _restIcTrf) ->
              (case (CPat_Con tag_ _restIcTrf _bindsIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CPat_Int :: Int ->
                T_CPat
sem_CPat_Int int_ =
    (case (CPat_Int int_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
sem_CPat_Char :: Char ->
                 T_CPat
sem_CPat_Char char_ =
    (case (CPat_Char char_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
sem_CPat_BoolExpr :: CExpr ->
                     T_CPat
sem_CPat_BoolExpr cexpr_ =
    (case (CPat_BoolExpr cexpr_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CPatFld -----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CPatFld 
   alternatives:
      alternative Fld:
         child lbl            : {HsName}
         child offset         : CExpr 
         child bind           : CBind 
         child fldAnns        : CBindAnnL 
         visit 0:
            local isStrictChain : _
            local cTrf        : _
-}
-- cata
sem_CPatFld :: CPatFld ->
               T_CPatFld
sem_CPatFld (CPatFld_Fld _lbl _offset _bind _fldAnns) =
    (sem_CPatFld_Fld _lbl (sem_CExpr _offset) (sem_CBind _bind) (sem_CBindAnnL _fldAnns))
-- semantic domain
type T_CPatFld = ( CPatFld)
sem_CPatFld_Fld :: HsName ->
                   T_CExpr ->
                   T_CBind ->
                   T_CBindAnnL ->
                   T_CPatFld
sem_CPatFld_Fld lbl_ offset_ bind_ fldAnns_ =
    (case (False) of
     { _isStrictChain ->
     (case (_isStrictChain) of
      { _bindOisStrictChain ->
      (case (_isStrictChain) of
       { _offsetOisStrictChain ->
       (case (fldAnns_) of
        { ( _fldAnnsIcTrf) ->
            (case (bind_ _bindOisStrictChain) of
             { ( _bindIbinds,_bindIcTrf,_bindIisStrictChain) ->
                 (case (offset_ _offsetOisStrictChain) of
                  { ( _offsetIbinds,_offsetIcTrf,_offsetIflatExpr,_offsetIisStrictChain,_offsetImbLift) ->
                      (case (CPatFld_Fld lbl_ _offsetIcTrf _bindIcTrf _fldAnnsIcTrf) of
                       { _cTrf ->
                       (case (_cTrf) of
                        { _lhsOcTrf ->
                        ( _lhsOcTrf) }) }) }) }) }) }) }) })
-- CPatFldL ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CPatFldL 
   alternatives:
      alternative Cons:
         child hd             : CPatFld 
         child tl             : CPatFldL 
         visit 0:
            local cTrf        : _
      alternative Nil:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CPatFldL :: CPatFldL ->
                T_CPatFldL
sem_CPatFldL list =
    (Prelude.foldr sem_CPatFldL_Cons sem_CPatFldL_Nil (Prelude.map sem_CPatFld list))
-- semantic domain
type T_CPatFldL = ( CPatFldL)
sem_CPatFldL_Cons :: T_CPatFld ->
                     T_CPatFldL ->
                     T_CPatFldL
sem_CPatFldL_Cons hd_ tl_ =
    (case (tl_) of
     { ( _tlIcTrf) ->
         (case (hd_) of
          { ( _hdIcTrf) ->
              (case ((:) _hdIcTrf _tlIcTrf) of
               { _cTrf ->
               (case (_cTrf) of
                { _lhsOcTrf ->
                ( _lhsOcTrf) }) }) }) })
sem_CPatFldL_Nil :: T_CPatFldL
sem_CPatFldL_Nil =
    (case ([]) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CPatRest ----------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CPatRest 
   alternatives:
      alternative Var:
         child nm             : {HsName}
         visit 0:
            local cTrf        : _
      alternative Empty:
         visit 0:
            local cTrf        : _
-}
-- cata
sem_CPatRest :: CPatRest ->
                T_CPatRest
sem_CPatRest (CPatRest_Var _nm) =
    (sem_CPatRest_Var _nm)
sem_CPatRest (CPatRest_Empty) =
    (sem_CPatRest_Empty)
-- semantic domain
type T_CPatRest = ( CPatRest)
sem_CPatRest_Var :: HsName ->
                    T_CPatRest
sem_CPatRest_Var nm_ =
    (case (CPatRest_Var nm_) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
sem_CPatRest_Empty :: T_CPatRest
sem_CPatRest_Empty =
    (case (CPatRest_Empty) of
     { _cTrf ->
     (case (_cTrf) of
      { _lhsOcTrf ->
      ( _lhsOcTrf) }) })
-- CodeAGItf ---------------------------------------------------
{-
   visit 0:
      synthesized attribute:
         cTrf                 : CModule 
   alternatives:
      alternative AGItf:
         child module         : CModule 
-}
-- cata
sem_CodeAGItf :: CodeAGItf ->
                 T_CodeAGItf
sem_CodeAGItf (CodeAGItf_AGItf _module) =
    (sem_CodeAGItf_AGItf (sem_CModule _module))
-- semantic domain
type T_CodeAGItf = ( CModule)
data Inh_CodeAGItf = Inh_CodeAGItf {}
data Syn_CodeAGItf = Syn_CodeAGItf {cTrf_Syn_CodeAGItf :: !(CModule)}
wrap_CodeAGItf :: T_CodeAGItf ->
                  Inh_CodeAGItf ->
                  Syn_CodeAGItf
wrap_CodeAGItf sem (Inh_CodeAGItf) =
    (let ( _lhsOcTrf) = sem
     in  (Syn_CodeAGItf _lhsOcTrf))
sem_CodeAGItf_AGItf :: T_CModule ->
                       T_CodeAGItf
sem_CodeAGItf_AGItf module_ =
    (case (module_) of
     { ( _moduleIcTrf) ->
         (case (_moduleIcTrf) of
          { _lhsOcTrf ->
          ( _lhsOcTrf) }) })