


module UHC.Light.Compiler.EH.MainAG_FuncDeps where

import Data.Char
import Data.List as List
import UHC.Util.Pretty
import UHC.Light.Compiler.Base.Common
import UHC.Light.Compiler.Base.TermLike
import UHC.Light.Compiler.Base.HsName.Builtin
import UHC.Light.Compiler.Opts
import UHC.Light.Compiler.Gam.Full
import UHC.Light.Compiler.Error
import UHC.Light.Compiler.Error.Pretty
import UHC.Light.Compiler.EH
import UHC.Light.Compiler.Ty.Pretty
import UHC.Light.Compiler.Ty.FitsInCommon
import UHC.Light.Compiler.Ty.FitsIn
import qualified UHC.Util.FastSeq as Seq
import UHC.Util.Utils
import UHC.Light.Compiler.Base.Trace
import UHC.Light.Compiler.Base.UnderDev
import UHC.Light.Compiler.VarMp
import UHC.Light.Compiler.Substitutable
import Data.Maybe
import UHC.Light.Compiler.Ty.Utils1
import UHC.Light.Compiler.Ty.Trf.Quantify
import UHC.Light.Compiler.Ty.Trf.Instantiate
import UHC.Light.Compiler.Ty
import UHC.Light.Compiler.Ty.FitsInCommon2
import UHC.Light.Compiler.Ty.FIEnv2
import qualified Data.Set as Set
import qualified Data.Map as Map
import Data.Set (Set)
import Data.Map (Map)
import UHC.Light.Compiler.Ty.Trf.FreshVar
import UHC.Light.Compiler.Ty.Ftv
import UHC.Util.Utils (groupSortOn)
import Control.Applicative ((<|>))
import UHC.Light.Compiler.AbstractCore
import UHC.Light.Compiler.AbstractCore.Utils
import UHC.Light.Compiler.Core
import UHC.Light.Compiler.Core.FFI
import UHC.Light.Compiler.Core.Utils
import UHC.Light.Compiler.Core.Pretty
import UHC.Light.Compiler.Foreign.Extract
import UHC.Light.Compiler.LamInfo
import UHC.Light.Compiler.CodeGen.RefGenerator
import qualified UHC.Light.Compiler.Core.SysF.AsTy as SysF
import UHC.Light.Compiler.FinalEnv
import UHC.Light.Compiler.Core.BindExtract
import UHC.Light.Compiler.Core.Subst
import Control.Monad.State
import UHC.Light.Compiler.Ty.Utils2
import UHC.Light.Compiler.Base.Target
import UHC.Light.Compiler.Core.Coercion
import UHC.Light.Compiler.Ty.Trf.MergePreds
import UHC.Light.Compiler.Ty.Trf.Canonic
import UHC.Light.Compiler.Gam.ClGam
import UHC.Light.Compiler.Pred
import UHC.Light.Compiler.Pred.CtxtRedOnly.RedGraph (redPruneReductionsUntil)
import UHC.Util.CHR
import UHC.Light.Compiler.CHR.CtxtRedOnly.Constraint
import UHC.Light.Compiler.CHR.CtxtRedOnly.Guard
import UHC.Light.Compiler.Pred.CtxtRedOnly.ToCHR
import UHC.Light.Compiler.Pred.CtxtRedOnly.Heuristics
import UHC.Light.Compiler.Pred.CtxtRedOnly.Evidence
import UHC.Light.Compiler.CHR.CtxtRedOnly.Solve
import UHC.Light.Compiler.Pred.CtxtRedOnly.EvidenceToCore
import UHC.Light.Compiler.Gam.ClassDefaultGam
import UHC.Light.Compiler.Ty.Trf.BetaReduce (tyBetaRedFull)
import UHC.Light.Compiler.Module.ImportExport
import UHC.Light.Compiler.Ty.UsedNames
import UHC.Light.Compiler.CodeGen.ImportUsedModules
import UHC.Light.Compiler.CodeGen.ModuleImportExportImpl
import UHC.Light.Compiler.CodeGen.BuiltinPrims
import UHC.Light.Compiler.Foreign
import UHC.Light.Compiler.Foreign
import UHC.Light.Compiler.Foreign.Pretty
import UHC.Light.Compiler.Deriving
import UHC.Light.Compiler.Generics
import UHC.Light.Compiler.VarMp.Utils

import UHC.Light.Compiler.EH.MainAG_common

-- FuncDeps ----------------------------------------------------
{-
   visit 0:
      chained attribute:
         gUniq                : UID
   visit 1:
      chained attribute:
         tyGam                : TyGam
   visit 2:
      chained attribute:
         tyKiGam              : TyKiGam
   visit 3:
      inherited attributes:
         clsTyArgs            : TyL
         finKiVarMp           : VarMp
         finTyKiGam           : TyKiGam
         finTyVarMp           : VarMp
         moduleNm             : HsName
         opts                 : EHCOpts
         sysfEnv              : ToSysfEnv
         tr                   : TraceOn -> [PP_Doc] -> TrPP
         tyKiGlobFreeTvarS    : TyVarIdS
         tyTyGlobFreeTvarS    : TyVarIdS
         tyTyTySigFreeTvarS   : TyVarIdS
         valTyGlobFreeTvarS   : TyVarIdS
      synthesized attributes:
         allErrSq             : ErrSq
         errSq                : ErrSq
         funcDeps             : [ClsFuncDep]
         gathMentrelFilterMp  : ModEntRelFilterMp
         pp                   : PP_Doc
         ppAST                : PP_Doc
         ppL                  : [PP_Doc]
         range                : Range
         trpp                 : TrPP
   alternatives:
      alternative Cons:
         child hd             : FuncDep 
         child tl             : FuncDeps 
         visit 3:
            local trppHere    : _
      alternative Nil:
         visit 3:
            local trppHere    : _
-}
sem_FuncDeps_Cons :: T_FuncDep ->
                     T_FuncDeps ->
                     T_FuncDeps

sem_FuncDeps_Cons hd_ tl_ | hd_ `seq` (tl_ `seq` (True)) =
    (\ _lhsIgUniq ->
         _lhsIgUniq `seq`
         ((case (_lhsIgUniq) of
           { _hdOgUniq | _hdOgUniq `seq` (True) ->
           (case (hd_ _hdOgUniq) of
            { ( _hdIgUniq,hd_1) | True ->
                (case (_hdIgUniq) of
                 { _tlOgUniq | _tlOgUniq `seq` (True) ->
                 (case (tl_ _tlOgUniq) of
                  { ( _tlIgUniq,tl_1) | True ->
                      (case (_tlIgUniq) of
                       { _lhsOgUniq | _lhsOgUniq `seq` (True) ->
                       (case ((let sem_FuncDeps_Cons_1 :: T_FuncDeps_1
                                   sem_FuncDeps_Cons_1 =
                                       (\ _lhsItyGam ->
                                            _lhsItyGam `seq`
                                            ((case (_lhsItyGam) of
                                              { _hdOtyGam | _hdOtyGam `seq` (True) ->
                                              (case (hd_1 _hdOtyGam) of
                                               { ( _hdItyGam,hd_2) | True ->
                                                   (case (_hdItyGam) of
                                                    { _tlOtyGam | _tlOtyGam `seq` (True) ->
                                                    (case (tl_1 _tlOtyGam) of
                                                     { ( _tlItyGam,tl_2) | True ->
                                                         (case (_tlItyGam) of
                                                          { _lhsOtyGam | _lhsOtyGam `seq` (True) ->
                                                          (case ((let sem_FuncDeps_Cons_2 :: T_FuncDeps_2
                                                                      sem_FuncDeps_Cons_2 =
                                                                          (\ _lhsItyKiGam ->
                                                                               _lhsItyKiGam `seq`
                                                                               ((case (_lhsItyKiGam) of
                                                                                 { _hdOtyKiGam | _hdOtyKiGam `seq` (True) ->
                                                                                 (case (hd_2 _hdOtyKiGam) of
                                                                                  { ( _hdItyKiGam,hd_3) | True ->
                                                                                      (case (_hdItyKiGam) of
                                                                                       { _tlOtyKiGam | _tlOtyKiGam `seq` (True) ->
                                                                                       (case (tl_2 _tlOtyKiGam) of
                                                                                        { ( _tlItyKiGam,tl_3) | True ->
                                                                                            (case (_tlItyKiGam) of
                                                                                             { _lhsOtyKiGam | _lhsOtyKiGam `seq` (True) ->
                                                                                             (case ((let sem_FuncDeps_Cons_3 :: T_FuncDeps_3
                                                                                                         sem_FuncDeps_Cons_3 =
                                                                                                             (\ _lhsIclsTyArgs
                                                                                                                _lhsIfinKiVarMp
                                                                                                                _lhsIfinTyKiGam
                                                                                                                _lhsIfinTyVarMp
                                                                                                                _lhsImoduleNm
                                                                                                                _lhsIopts
                                                                                                                _lhsIsysfEnv
                                                                                                                _lhsItr
                                                                                                                _lhsItyKiGlobFreeTvarS
                                                                                                                _lhsItyTyGlobFreeTvarS
                                                                                                                _lhsItyTyTySigFreeTvarS
                                                                                                                _lhsIvalTyGlobFreeTvarS ->
                                                                                                                  _lhsIclsTyArgs `seq`
                                                                                                                  (_lhsIfinKiVarMp `seq`
                                                                                                                   (_lhsIfinTyKiGam `seq`
                                                                                                                    (_lhsIfinTyVarMp `seq`
                                                                                                                     (_lhsImoduleNm `seq`
                                                                                                                      (_lhsIopts `seq`
                                                                                                                       (_lhsIsysfEnv `seq`
                                                                                                                        (_lhsItr `seq`
                                                                                                                         (_lhsItyKiGlobFreeTvarS `seq`
                                                                                                                          (_lhsItyTyGlobFreeTvarS `seq`
                                                                                                                           (_lhsItyTyTySigFreeTvarS `seq`
                                                                                                                            (_lhsIvalTyGlobFreeTvarS `seq`
                                                                                                                             ((case (_lhsIvalTyGlobFreeTvarS) of
                                                                                                                               { _tlOvalTyGlobFreeTvarS | _tlOvalTyGlobFreeTvarS `seq` (True) ->
                                                                                                                               (case (_lhsItyTyTySigFreeTvarS) of
                                                                                                                                { _tlOtyTyTySigFreeTvarS | _tlOtyTyTySigFreeTvarS `seq` (True) ->
                                                                                                                                (case (_lhsItyTyGlobFreeTvarS) of
                                                                                                                                 { _tlOtyTyGlobFreeTvarS | _tlOtyTyGlobFreeTvarS `seq` (True) ->
                                                                                                                                 (case (_lhsItyKiGlobFreeTvarS) of
                                                                                                                                  { _tlOtyKiGlobFreeTvarS | _tlOtyKiGlobFreeTvarS `seq` (True) ->
                                                                                                                                  (case (_lhsItr) of
                                                                                                                                   { _tlOtr | _tlOtr `seq` (True) ->
                                                                                                                                   (case (_lhsIsysfEnv) of
                                                                                                                                    { _tlOsysfEnv | _tlOsysfEnv `seq` (True) ->
                                                                                                                                    (case (_lhsIopts) of
                                                                                                                                     { _tlOopts | _tlOopts `seq` (True) ->
                                                                                                                                     (case (_lhsImoduleNm) of
                                                                                                                                      { _tlOmoduleNm | _tlOmoduleNm `seq` (True) ->
                                                                                                                                      (case (_lhsIfinTyVarMp) of
                                                                                                                                       { _tlOfinTyVarMp | _tlOfinTyVarMp `seq` (True) ->
                                                                                                                                       (case (_lhsIfinTyKiGam) of
                                                                                                                                        { _tlOfinTyKiGam | _tlOfinTyKiGam `seq` (True) ->
                                                                                                                                        (case (_lhsIfinKiVarMp) of
                                                                                                                                         { _tlOfinKiVarMp | _tlOfinKiVarMp `seq` (True) ->
                                                                                                                                         (case (_lhsIclsTyArgs) of
                                                                                                                                          { _tlOclsTyArgs | _tlOclsTyArgs `seq` (True) ->
                                                                                                                                          (case (tl_3 _tlOclsTyArgs _tlOfinKiVarMp _tlOfinTyKiGam _tlOfinTyVarMp _tlOmoduleNm _tlOopts _tlOsysfEnv _tlOtr _tlOtyKiGlobFreeTvarS _tlOtyTyGlobFreeTvarS _tlOtyTyTySigFreeTvarS _tlOvalTyGlobFreeTvarS) of
                                                                                                                                           { ( _tlIallErrSq,_tlIerrSq,_tlIfuncDeps,_tlIgathMentrelFilterMp,_tlIpp,_tlIppAST,_tlIppL,_tlIrange,_tlItrpp) | True ->
                                                                                                                                               (case (_lhsIvalTyGlobFreeTvarS) of
                                                                                                                                                { _hdOvalTyGlobFreeTvarS | _hdOvalTyGlobFreeTvarS `seq` (True) ->
                                                                                                                                                (case (_lhsItyTyTySigFreeTvarS) of
                                                                                                                                                 { _hdOtyTyTySigFreeTvarS | _hdOtyTyTySigFreeTvarS `seq` (True) ->
                                                                                                                                                 (case (_lhsItyTyGlobFreeTvarS) of
                                                                                                                                                  { _hdOtyTyGlobFreeTvarS | _hdOtyTyGlobFreeTvarS `seq` (True) ->
                                                                                                                                                  (case (_lhsItyKiGlobFreeTvarS) of
                                                                                                                                                   { _hdOtyKiGlobFreeTvarS | _hdOtyKiGlobFreeTvarS `seq` (True) ->
                                                                                                                                                   (case (_lhsItr) of
                                                                                                                                                    { _hdOtr | _hdOtr `seq` (True) ->
                                                                                                                                                    (case (_lhsIsysfEnv) of
                                                                                                                                                     { _hdOsysfEnv | _hdOsysfEnv `seq` (True) ->
                                                                                                                                                     (case (_lhsIopts) of
                                                                                                                                                      { _hdOopts | _hdOopts `seq` (True) ->
                                                                                                                                                      (case (_lhsImoduleNm) of
                                                                                                                                                       { _hdOmoduleNm | _hdOmoduleNm `seq` (True) ->
                                                                                                                                                       (case (_lhsIfinTyVarMp) of
                                                                                                                                                        { _hdOfinTyVarMp | _hdOfinTyVarMp `seq` (True) ->
                                                                                                                                                        (case (_lhsIfinTyKiGam) of
                                                                                                                                                         { _hdOfinTyKiGam | _hdOfinTyKiGam `seq` (True) ->
                                                                                                                                                         (case (_lhsIfinKiVarMp) of
                                                                                                                                                          { _hdOfinKiVarMp | _hdOfinKiVarMp `seq` (True) ->
                                                                                                                                                          (case (_lhsIclsTyArgs) of
                                                                                                                                                           { _hdOclsTyArgs | _hdOclsTyArgs `seq` (True) ->
                                                                                                                                                           (case (hd_3 _hdOclsTyArgs _hdOfinKiVarMp _hdOfinTyKiGam _hdOfinTyVarMp _hdOmoduleNm _hdOopts _hdOsysfEnv _hdOtr _hdOtyKiGlobFreeTvarS _hdOtyTyGlobFreeTvarS _hdOtyTyTySigFreeTvarS _hdOvalTyGlobFreeTvarS) of
                                                                                                                                                            { ( _hdIallErrSq,_hdIerrSq,_hdIfuncDeps,_hdIgathMentrelFilterMp,_hdIpp,_hdIppAST,_hdIrange,_hdItrpp) | True ->
                                                                                                                                                                (case (_hdIallErrSq `Seq.union` _tlIallErrSq) of
                                                                                                                                                                 { _lhsOallErrSq | _lhsOallErrSq `seq` (True) ->
                                                                                                                                                                 (case (_hdIerrSq `Seq.union` _tlIerrSq) of
                                                                                                                                                                  { _lhsOerrSq | _lhsOerrSq `seq` (True) ->
                                                                                                                                                                  (case (_hdIfuncDeps ++ _tlIfuncDeps) of
                                                                                                                                                                   { _lhsOfuncDeps | _lhsOfuncDeps `seq` (True) ->
                                                                                                                                                                   (case (_hdIgathMentrelFilterMp `mentrelFilterMpUnion` _tlIgathMentrelFilterMp) of
                                                                                                                                                                    { _lhsOgathMentrelFilterMp | _lhsOgathMentrelFilterMp `seq` (True) ->
                                                                                                                                                                    (case (_hdIpp >-< _tlIpp) of
                                                                                                                                                                     { _lhsOpp | _lhsOpp `seq` (True) ->
                                                                                                                                                                     (case (trppEmpty) of
                                                                                                                                                                      { _trppHere | _trppHere `seq` (True) ->
                                                                                                                                                                      (case (ppNestTrPP ["FuncDeps","Cons"] [] [_hdIppAST,_tlIppAST] _trppHere) of
                                                                                                                                                                       { _lhsOppAST | _lhsOppAST `seq` (True) ->
                                                                                                                                                                       (case (_hdIpp : _tlIppL) of
                                                                                                                                                                        { _lhsOppL | _lhsOppL `seq` (True) ->
                                                                                                                                                                        (case (_hdIrange `rangeUnion` _tlIrange) of
                                                                                                                                                                         { _lhsOrange | _lhsOrange `seq` (True) ->
                                                                                                                                                                         (case (_hdItrpp >< _tlItrpp) of
                                                                                                                                                                          { _lhsOtrpp | _lhsOtrpp `seq` (True) ->
                                                                                                                                                                          ( _lhsOallErrSq,_lhsOerrSq,_lhsOfuncDeps,_lhsOgathMentrelFilterMp,_lhsOpp,_lhsOppAST,_lhsOppL,_lhsOrange,_lhsOtrpp) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }) }))))))))))))))
                                                                                                     in  sem_FuncDeps_Cons_3)) of
                                                                                              { ( sem_FuncDeps_3) | True ->
                                                                                              ( _lhsOtyKiGam,sem_FuncDeps_3) }) }) }) }) }) })))
                                                                  in  sem_FuncDeps_Cons_2)) of
                                                           { ( sem_FuncDeps_2) | True ->
                                                           ( _lhsOtyGam,sem_FuncDeps_2) }) }) }) }) }) })))
                               in  sem_FuncDeps_Cons_1)) of
                        { ( sem_FuncDeps_1) | True ->
                        ( _lhsOgUniq,sem_FuncDeps_1) }) }) }) }) }) })))

sem_FuncDeps_Nil :: T_FuncDeps

sem_FuncDeps_Nil =
    (\ _lhsIgUniq ->
         _lhsIgUniq `seq`
         ((case (_lhsIgUniq) of
           { _lhsOgUniq | _lhsOgUniq `seq` (True) ->
           (case ((let sem_FuncDeps_Nil_1 :: T_FuncDeps_1
                       sem_FuncDeps_Nil_1 =
                           (\ _lhsItyGam ->
                                _lhsItyGam `seq`
                                ((case (_lhsItyGam) of
                                  { _lhsOtyGam | _lhsOtyGam `seq` (True) ->
                                  (case ((let sem_FuncDeps_Nil_2 :: T_FuncDeps_2
                                              sem_FuncDeps_Nil_2 =
                                                  (\ _lhsItyKiGam ->
                                                       _lhsItyKiGam `seq`
                                                       ((case (_lhsItyKiGam) of
                                                         { _lhsOtyKiGam | _lhsOtyKiGam `seq` (True) ->
                                                         (case ((let sem_FuncDeps_Nil_3 :: T_FuncDeps_3
                                                                     sem_FuncDeps_Nil_3 =
                                                                         (\ _lhsIclsTyArgs
                                                                            _lhsIfinKiVarMp
                                                                            _lhsIfinTyKiGam
                                                                            _lhsIfinTyVarMp
                                                                            _lhsImoduleNm
                                                                            _lhsIopts
                                                                            _lhsIsysfEnv
                                                                            _lhsItr
                                                                            _lhsItyKiGlobFreeTvarS
                                                                            _lhsItyTyGlobFreeTvarS
                                                                            _lhsItyTyTySigFreeTvarS
                                                                            _lhsIvalTyGlobFreeTvarS ->
                                                                              _lhsIclsTyArgs `seq`
                                                                              (_lhsIfinKiVarMp `seq`
                                                                               (_lhsIfinTyKiGam `seq`
                                                                                (_lhsIfinTyVarMp `seq`
                                                                                 (_lhsImoduleNm `seq`
                                                                                  (_lhsIopts `seq`
                                                                                   (_lhsIsysfEnv `seq`
                                                                                    (_lhsItr `seq`
                                                                                     (_lhsItyKiGlobFreeTvarS `seq`
                                                                                      (_lhsItyTyGlobFreeTvarS `seq`
                                                                                       (_lhsItyTyTySigFreeTvarS `seq`
                                                                                        (_lhsIvalTyGlobFreeTvarS `seq`
                                                                                         ((case (Seq.empty) of
                                                                                           { _lhsOallErrSq | _lhsOallErrSq `seq` (True) ->
                                                                                           (case (Seq.empty) of
                                                                                            { _lhsOerrSq | _lhsOerrSq `seq` (True) ->
                                                                                            (case ([]) of
                                                                                             { _lhsOfuncDeps | _lhsOfuncDeps `seq` (True) ->
                                                                                             (case (Map.empty) of
                                                                                              { _lhsOgathMentrelFilterMp | _lhsOgathMentrelFilterMp `seq` (True) ->
                                                                                              (case (empty) of
                                                                                               { _lhsOpp | _lhsOpp `seq` (True) ->
                                                                                               (case (trppEmpty) of
                                                                                                { _trppHere | _trppHere `seq` (True) ->
                                                                                                (case (ppNestTrPP ["FuncDeps","Nil"] [] [] _trppHere) of
                                                                                                 { _lhsOppAST | _lhsOppAST `seq` (True) ->
                                                                                                 (case ([]) of
                                                                                                  { _lhsOppL | _lhsOppL `seq` (True) ->
                                                                                                  (case (emptyRange) of
                                                                                                   { _lhsOrange | _lhsOrange `seq` (True) ->
                                                                                                   (case (trppEmpty) of
                                                                                                    { _lhsOtrpp | _lhsOtrpp `seq` (True) ->
                                                                                                    ( _lhsOallErrSq,_lhsOerrSq,_lhsOfuncDeps,_lhsOgathMentrelFilterMp,_lhsOpp,_lhsOppAST,_lhsOppL,_lhsOrange,_lhsOtrpp) }) }) }) }) }) }) }) }) }) }))))))))))))))
                                                                 in  sem_FuncDeps_Nil_3)) of
                                                          { ( sem_FuncDeps_3) | True ->
                                                          ( _lhsOtyKiGam,sem_FuncDeps_3) }) })))
                                          in  sem_FuncDeps_Nil_2)) of
                                   { ( sem_FuncDeps_2) | True ->
                                   ( _lhsOtyGam,sem_FuncDeps_2) }) })))
                   in  sem_FuncDeps_Nil_1)) of
            { ( sem_FuncDeps_1) | True ->
            ( _lhsOgUniq,sem_FuncDeps_1) }) })))

