


module UHC.Light.Compiler.EH.MainAG_TyExprAnn where

import Data.Char
import Data.List as List
import UHC.Util.Pretty
import UHC.Light.Compiler.Base.Common
import UHC.Light.Compiler.Base.TermLike
import UHC.Light.Compiler.Base.HsName.Builtin
import UHC.Light.Compiler.Opts
import UHC.Light.Compiler.Gam.Full
import UHC.Light.Compiler.Error
import UHC.Light.Compiler.Error.Pretty
import UHC.Light.Compiler.EH
import UHC.Light.Compiler.Ty.Pretty
import UHC.Light.Compiler.Ty.FitsInCommon
import UHC.Light.Compiler.Ty.FitsIn
import qualified UHC.Util.FastSeq as Seq
import UHC.Util.Utils
import UHC.Light.Compiler.Base.Trace
import UHC.Light.Compiler.Base.UnderDev
import UHC.Light.Compiler.VarMp
import UHC.Light.Compiler.Substitutable
import Data.Maybe
import UHC.Light.Compiler.Ty.Utils1
import UHC.Light.Compiler.Ty.Trf.Quantify
import UHC.Light.Compiler.Ty.Trf.Instantiate
import UHC.Light.Compiler.Ty
import UHC.Light.Compiler.Ty.FitsInCommon2
import UHC.Light.Compiler.Ty.FIEnv2
import qualified Data.Set as Set
import qualified Data.Map as Map
import Data.Set (Set)
import Data.Map (Map)
import UHC.Light.Compiler.Ty.Trf.FreshVar
import UHC.Light.Compiler.Ty.Ftv
import UHC.Util.Utils (groupSortOn)
import Control.Applicative ((<|>))
import UHC.Light.Compiler.AbstractCore
import UHC.Light.Compiler.AbstractCore.Utils
import UHC.Light.Compiler.Core
import UHC.Light.Compiler.Core.FFI
import UHC.Light.Compiler.Core.Utils
import UHC.Light.Compiler.Core.Pretty
import UHC.Light.Compiler.Foreign.Extract
import UHC.Light.Compiler.LamInfo
import UHC.Light.Compiler.CodeGen.RefGenerator
import qualified UHC.Light.Compiler.Core.SysF.AsTy as SysF
import UHC.Light.Compiler.FinalEnv
import UHC.Light.Compiler.Core.BindExtract
import UHC.Light.Compiler.Core.Subst
import Control.Monad.State
import UHC.Light.Compiler.Ty.Utils2
import UHC.Light.Compiler.Base.Target
import UHC.Light.Compiler.Core.Coercion
import UHC.Light.Compiler.Ty.Trf.MergePreds
import UHC.Light.Compiler.Ty.Trf.Canonic
import UHC.Light.Compiler.Gam.ClGam
import UHC.Light.Compiler.Pred
import UHC.Light.Compiler.Pred.CtxtRedOnly.RedGraph (redPruneReductionsUntil)
import UHC.Util.CHR
import UHC.Light.Compiler.CHR.CtxtRedOnly.Constraint
import UHC.Light.Compiler.CHR.CtxtRedOnly.Guard
import UHC.Light.Compiler.Pred.CtxtRedOnly.ToCHR
import UHC.Light.Compiler.Pred.CtxtRedOnly.Heuristics
import UHC.Light.Compiler.Pred.CtxtRedOnly.Evidence
import UHC.Light.Compiler.CHR.CtxtRedOnly.Solve
import UHC.Light.Compiler.Pred.CtxtRedOnly.EvidenceToCore
import UHC.Light.Compiler.Gam.ClassDefaultGam
import UHC.Light.Compiler.Ty.Trf.BetaReduce (tyBetaRedFull)
import UHC.Light.Compiler.Module.ImportExport
import UHC.Light.Compiler.Ty.UsedNames
import UHC.Light.Compiler.CodeGen.ImportUsedModules
import UHC.Light.Compiler.CodeGen.ModuleImportExportImpl
import UHC.Light.Compiler.CodeGen.BuiltinPrims
import UHC.Light.Compiler.Foreign
import UHC.Light.Compiler.Foreign
import UHC.Light.Compiler.Foreign.Pretty
import UHC.Light.Compiler.Deriving
import UHC.Light.Compiler.Generics
import UHC.Light.Compiler.VarMp.Utils

import UHC.Light.Compiler.EH.MainAG_common

-- TyExprAnn ---------------------------------------------------
{-
   visit 0:
      synthesized attributes:
         ann                  : TyAnn
         isEmpty              : Bool
         mbStrictness         : Maybe Strictness
         pp                   : PP_Doc
   alternatives:
      alternative Empty:
         visit 0:
            local pp          : _
      alternative Strictness:
         child strictness     : {Strictness}
         visit 0:
            local pp          : _
-}
sem_TyExprAnn_Empty :: T_TyExprAnn

sem_TyExprAnn_Empty =
    (case (TyAnn_Empty) of
     { _lhsOann | _lhsOann `seq` (True) ->
     (case (True) of
      { _lhsOisEmpty | _lhsOisEmpty `seq` (True) ->
      (case (Nothing) of
       { _lhsOmbStrictness | _lhsOmbStrictness `seq` (True) ->
       (case (empty) of
        { _pp | _pp `seq` (True) ->
        (case (_pp) of
         { _lhsOpp | _lhsOpp `seq` (True) ->
         ( _lhsOann,_lhsOisEmpty,_lhsOmbStrictness,_lhsOpp) }) }) }) }) })

sem_TyExprAnn_Strictness :: Strictness ->
                            T_TyExprAnn

sem_TyExprAnn_Strictness strictness_ | strictness_ `seq` (True) =
    (case (TyAnn_Strictness strictness_) of
     { _lhsOann | _lhsOann `seq` (True) ->
     (case (False) of
      { _lhsOisEmpty | _lhsOisEmpty `seq` (True) ->
      (case (Just strictness_) of
       { _lhsOmbStrictness | _lhsOmbStrictness `seq` (True) ->
       (case ("@" >|< show strictness_) of
        { _pp | _pp `seq` (True) ->
        (case (_pp) of
         { _lhsOpp | _lhsOpp `seq` (True) ->
         ( _lhsOann,_lhsOisEmpty,_lhsOmbStrictness,_lhsOpp) }) }) }) }) })

