{-# LANGUAGE GADTs #-}

module UHC.Light.Compiler.EHC.ASTTypes
( AST_HS, AST_EH, AST_HS_Sem_Check, AST_EH_Sem_Check, AST_HS_Inh_Check, AST_EH_Inh_Check
, AST_Core
, AST_Core_Sem_ToCoreRun
, AST_Core_Sem_Check
, AST_CoreRun
, AST_CoreRun_Sem_Check
, AST_CoreRun_Sem_Mod
, AST_HS_Sem_Mod
, AST_HI )
where
import UHC.Light.Compiler.Base.Common
import qualified UHC.Light.Compiler.EH as EH
import qualified UHC.Light.Compiler.HS as HS
import qualified UHC.Light.Compiler.Core as Core
import qualified UHC.Light.Compiler.CoreRun as CoreRun
import qualified UHC.Light.Compiler.EH.Main as EHSem
import qualified UHC.Light.Compiler.HS.MainAG as HSSem
import qualified UHC.Light.Compiler.Core.ToGrin as Core2GrSem
import qualified UHC.Light.Compiler.Core.ToCoreRun as Core2CoreRunSem
import qualified UHC.Light.Compiler.Core.Check as Core2ChkSem
import qualified UHC.Light.Compiler.CoreRun.Check as CoreRun2ChkSem
import qualified UHC.Light.Compiler.CoreRun.ModImpExp as CoreRunSemMod
import qualified UHC.Light.Compiler.HI as HI
import qualified UHC.Light.Compiler.HS.ModImpExp as HSSemMod











{-# LINE 70 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_HS					= HS.AGItf
type AST_EH					= EH.AGItf

type AST_HS_Sem_Check		= HSSem.Syn_AGItf
type AST_EH_Sem_Check		= EHSem.Syn_AGItf

type AST_HS_Inh_Check		= HSSem.Inh_AGItf
type AST_EH_Inh_Check		= EHSem.Inh_AGItf

{-# LINE 81 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_HS_Sem_Mod			= HSSemMod.Syn_AGItf

{-# LINE 85 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_HI					= HI.HIInfo

{-# LINE 89 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_Core				= Core.CModule

{-# LINE 99 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_Core_Sem_ToCoreRun	= Core2CoreRunSem.Syn_CodeAGItf

{-# LINE 103 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_Core_Sem_Check		= Core2ChkSem.Syn_CodeAGItf

{-# LINE 107 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_CoreRun			= CoreRun.Mod

{-# LINE 111 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_CoreRun_Sem_Check	= CoreRun2ChkSem.Syn_AGItf

{-# LINE 115 "src/ehc/EHC/ASTTypes.chs" #-}
type AST_CoreRun_Sem_Mod	= CoreRunSemMod.Syn_AGItf

